// hmct110.h

// error code
#define NOT_FOUND				0x00000001			// ޲݂Ȃ
#define ALREADY_OPENED			0x00000002			// d
#define INSUFFICIENT_MEMORY		0x00000004			// ؕs
#define INVALID_HANDLE			0x00000008			// 
#define NOT_READY				0x00000010			// ޲̓o߰Ďgps\
#define ILLEGAL_DEVICE			0x00000020			// ް޺ނǂ߂Ȃ
#define ILLEGAL_PARAM			0x00000100			// ͈͊O
#define ALREADY_WAITING			0x00001000			// ݑҋ@
#define WAITING_CANCELED		0x00002000			// ݷݾ
#define CYC_COM_ERROR			0x00010000			// دʐMװ
#define CYC_COM_STOP			0x00020000			// دʐM~
#define DATA_COM_ERROR			0x00040000			// ްʐMװ
#define COM_OTHER_ERROR			0x00080000			// ̑̒ʐMװ
#define OTHER_ERROR				0x80000000			// gp޲ްM

// device information structure
typedef struct _HMCT110INFO {

	DWORD			dwBusNumber;		// oXԍ
	DWORD			dwBaseAddress;		// x[XAhX
	DWORD			dwIrqNo;			// IRQ ԍ
	DWORD			dwNumber;			// Ǘԍ
	DWORD			dwAddressSpace;		// AhX(1:I/O, 0:MEM)
	DWORD			dwAccessMode;		// gpԃ[h(1:8byte, 0:512byte)

} HMCT110INFO, * PHMCT110INFO;


//	DLL functions
#ifdef __cplusplus
extern "C"
{
#endif

__declspec(dllimport) DWORD WINAPI mct110_GetMstBrdCount(DWORD*);					//1@MCAT110̎擾
__declspec(dllimport) DWORD WINAPI mct110_GetMstBrdInfo(DWORD*, HMCT110INFO*);		//2	 MCAT110foCX̎擾
__declspec(dllimport) DWORD WINAPI mct110_OpenMstBrd(DWORD*, HMCT110INFO*);			//3	 MCAT110̃I[v
__declspec(dllimport) DWORD WINAPI mct110_CloseMstBrd(DWORD);						//4	 MCAT110̃N[Y
__declspec(dllimport) DWORD WINAPI mct110_rCenMsts(DWORD,WORD,WORD*);				//5	 Z^[foCXXe[^XǏo
__declspec(dllimport) DWORD WINAPI mct110_wCenCmd(DWORD,WORD,WORD);					//6	 Z^[foCXR}h
__declspec(dllimport) DWORD WINAPI mct110_rCenIsts(DWORD,WORD,WORD*);				//7	 Z^[foCX݃Xe[^XǏo
__declspec(dllimport) DWORD WINAPI mct110_rCenBuf(DWORD,WORD,WORD*);				//8	 Z^[foCXo̓obt@Ǐo
__declspec(dllimport) DWORD WINAPI mct110_wCenBuf(DWORD,WORD,WORD);					// 	 Z^[foCXo̓obt@
__declspec(dllimport) DWORD WINAPI mct110_rCenRFiFo(DWORD,WORD,WORD*);				//9  Z^[foCXMpehenǏo
__declspec(dllimport) DWORD WINAPI mct110_wCenSFiFo(DWORD,WORD,WORD);				//   Z^[foCXMpehen
__declspec(dllimport) DWORD WINAPI mct110_rLclCycErr(DWORD,WORD,WORD,WORD*);		//10 TCNbNʐMG[tOǏo
__declspec(dllimport) DWORD WINAPI mct110_wLclCycErr(DWORD,WORD,WORD,WORD);			//   TCNbNʐMG[tOZbg
__declspec(dllimport) DWORD WINAPI mct110_rLclInfo(DWORD,WORD,WORD,BYTE*);			//11 [JfoCX(DIOCӰ)Ǐo
__declspec(dllimport) DWORD WINAPI mct110_wLclInfo(DWORD,WORD,WORD,BYTE);			//   [JfoCX(DIOCӰ)񏑍
__declspec(dllimport) DWORD WINAPI mct110_rLclSetInt(DWORD,WORD,WORD,WORD*);		//12 [JfoCX(DIOCӰ)͕ωݐݒԓǏo
__declspec(dllimport) DWORD WINAPI mct110_wLclSetInt(DWORD,WORD,WORD,WORD);			//   [JfoCX(DIOCӰ)͕ωݐݒ菑
__declspec(dllimport) DWORD WINAPI mct110_rLclInt(DWORD,WORD,WORD,WORD*);			//13 [JfoCX(DIOCӰ)͕ω݃tOǏo
__declspec(dllimport) DWORD WINAPI mct110_wLclInt(DWORD,WORD,WORD,WORD);			//   [JfoCX(DIOCӰ)͕ω݃tOZbg
__declspec(dllimport) DWORD WINAPI mct110_rIoPortB(DWORD,WORD,WORD,WORD,BYTE*);		//14 DIO޲w|[gPoCgǏo
__declspec(dllimport) DWORD WINAPI mct110_wIoPortB(DWORD,WORD,WORD,WORD,BYTE);		//   DIO޲w|[gPoCg
__declspec(dllimport) DWORD WINAPI mct110_rIoPortW(DWORD,WORD,WORD,WORD,WORD*);		//   DIO޲w|[gQoCgǏo
__declspec(dllimport) DWORD WINAPI mct110_wIoPortW(DWORD,WORD,WORD,WORD,WORD);		//   DIO޲w|[gQoCg
__declspec(dllimport) DWORD WINAPI mct110_rPclPort(DWORD,WORD,WORD,BYTE*);			//15 Ӱ޲o̓|[gPoCgǏo
__declspec(dllimport) DWORD WINAPI mct110_wPclPort(DWORD,WORD,WORD,BYTE);			//   Ӱ޲o̓|[gPoCg
__declspec(dllimport) DWORD WINAPI mct110_rPclMsts(DWORD,WORD,WORD,WORD*);			//16 Ӱ޲CXe[^XǏo
__declspec(dllimport) DWORD WINAPI mct110_wPclCmd(DWORD,WORD,WORD,WORD);			//17 Ӱ޲R}h
__declspec(dllimport) DWORD WINAPI mct110_rPclReg(DWORD,WORD,WORD,WORD,DWORD*);		//18 Ӱ޲WX^Ǐo
__declspec(dllimport) DWORD WINAPI mct110_wPclReg(DWORD,WORD,WORD,WORD,DWORD);		//   Ӱ޲WX^
__declspec(dllimport) DWORD WINAPI mct110_rOptPortB(DWORD,WORD,BYTE*);				//19 IvV|[gPoCgǏo
__declspec(dllimport) DWORD WINAPI mct110_rOptPortW(DWORD,WORD,WORD*);				//   IvV|[gQoCgǏo
__declspec(dllimport) DWORD WINAPI mct110_wOptPortB(DWORD,WORD,BYTE);				//   IvV|[gPoCg
__declspec(dllimport) DWORD WINAPI mct110_wOptPortW(DWORD,WORD,WORD);				//   IvV|[gQoCg
__declspec(dllimport) DWORD WINAPI mct110_rCenPortW(DWORD,WORD,WORD*);				//20 Z^[foCXw|[gQoCgǏo
__declspec(dllimport) DWORD WINAPI mct110_wCenPortW(DWORD,WORD,WORD);				//   Z^[foCXw|[gQoCg


#ifdef __cplusplus
}
#endif

