//
// g9001ctl.c
// G9001֐
//

#include <windows.h>
#include "hmct110.h"
#include "g9001ctl.h"
#include "s1d32000.h"

// G9001̏
DWORD m_init( DWORD hDev )
{
	DWORD dwRet = 0;
	
	dwRet |= mct110_wCenCmd( hDev, 0, 0x0100 );	// G9001Zbg
	return (dwRet);
}

// ђʐMJn
DWORD m_strt_sys( DWORD hDev )
{
	DWORD dwRet = 0;
	WORD  wSts,
		  wTimeOut;

	// VXeʐM	
	dwRet = mct110_wCenCmd( hDev, 0, 0x1000 );	// ђʐM
	if( dwRet )		return (dwRet);
	// ђʐM҂
	wSts = 0;
	wTimeOut=1000;
	while((wSts & 1) == 0) {
		dwRet = mct110_rCenMsts( hDev, 0, &wSts );
		if( dwRet ) {
			return (dwRet);
		} else {
			if( wSts & 0x10 ) {			// ђʐMװ
				return (DATA_COM_ERROR);
			} else if( wSts & 0x40 ) {	// ђʐMɒʐMs
				return (ILL_ACCESS_COM);
			} else {
				Sleep(1);
				wTimeOut--;
				if(wTimeOut==0) {
					return (COM_OTHER_ERROR);	
				}
			}
		}
	}
	return (0);
}

// دʐMJn	
DWORD m_strt_cyc( DWORD hDev )
{
	DWORD dwRet = 0;
	WORD  wSts,
		  wIst,
		  wTimeOut;

	// دʐMJn
	dwRet = mct110_wCenCmd( hDev, 0, 0x3000 );
	if( dwRet )		return (dwRet);

	// دʐMJn҂
	wSts = 0;
	wTimeOut=1000;
	while((wSts & 0x1000) == 0) {
		dwRet = mct110_rCenMsts( hDev, 0, &wSts );
		if( dwRet ) {
			return (dwRet);
		} else {
			Sleep( 1 );
			if( wSts & 0x0008 ) {								// دʐMװ
				dwRet = mct110_wCenCmd( hDev, 0, 0x3100 );	// دʐM~
				return (CYC_COM_ERROR);
			} else if( wSts & 0x40 ) {
				dwRet = mct110_rCenIsts( hDev, 0, &wIst );
				if( dwRet ) {
					return (dwRet);
				} else {
					if(( wIst & 0xf000 ) == 0x1000 ) {			// [JfoCXȂ
						break;
					} else if(( wIst & 0xf000 ) == 0x3000 ) {	// ђʐMɒʐMs
						return (ILL_ACCESS_COM);
					} else if(( wIst & 0xf000 ) == 0x4000 ) {
						return (SEND_DATA_NONUSE);
					}
				}
			} else {
				Sleep(1);
				wTimeOut--;
				if(wTimeOut==0) {
					return (COM_OTHER_ERROR);	
				}
			}
		}
	}
	return (0);
}

// دʐM~	
DWORD m_stop_cyc( DWORD hDev )
{
	DWORD dwRet = 0;
	WORD  wSts,
		  wTimeOut;

	dwRet = mct110_rCenMsts( hDev, 0, &wSts );
	if(dwRet) {
		return (dwRet);
	}
	if( wSts & 0x1000 ) {	// دʐM
		dwRet = mct110_wCenCmd( hDev, 0, 0x3100 );
		if(dwRet) {
			return (dwRet);
		}
		dwRet = mct110_rCenMsts( hDev, 0, &wSts );
		if(dwRet) {
			return (dwRet);
		}
		wTimeOut=1000;
		while( wSts & 0x1000 ) {
			dwRet = mct110_rCenMsts( hDev, 0, &wSts );
			if(dwRet) {
				return (dwRet);
			} else {
				Sleep(1);
				wTimeOut--;
				if(wTimeOut==0) {
					return (COM_OTHER_ERROR);	
				}
			}
			if( wSts & 0x8 ) {		// دʐMװ
				return (CYC_COM_ERROR);
			}
		}
	}
	return (0);
}