#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "t1mct00.h"

//
// dio menu
//
LRESULT dioMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	DWORD	hdev;
	WORD	wLno;
	WORD	wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );	
	switch( wParam ) {
	case IDD_LO0:	d_outp( hdev, wLno, wMid, 0x0001 );	break;
	case IDD_LO1:	d_outp( hdev, wLno, wMid, 0x0002 );	break;
	case IDD_LO2:	d_outp( hdev, wLno, wMid, 0x0004 );	break;
	case IDD_LO3:	d_outp( hdev, wLno, wMid, 0x0008 );	break;
	case IDD_LO4:	d_outp( hdev, wLno, wMid, 0x0010 );	break;
	case IDD_LO5:	d_outp( hdev, wLno, wMid, 0x0020 );	break;
	case IDD_LO6:	d_outp( hdev, wLno, wMid, 0x0040 );	break;
	case IDD_LO7:	d_outp( hdev, wLno, wMid, 0x0080 );	break;
	case IDD_LO8:	d_outp( hdev, wLno, wMid, 0x0100 );	break;
	case IDD_LO9:	d_outp( hdev, wLno, wMid, 0x0200 );	break;
	case IDD_LOA:	d_outp( hdev, wLno, wMid, 0x0400 );	break;
	case IDD_LOB:	d_outp( hdev, wLno, wMid, 0x0800 );	break;
	case IDD_LOC:	d_outp( hdev, wLno, wMid, 0x1000 );	break;
	case IDD_LOD:	d_outp( hdev, wLno, wMid, 0x2000 );	break;
	case IDD_LOE:	d_outp( hdev, wLno, wMid, 0x4000 );	break;
	case IDD_LOF:	d_outp( hdev, wLno, wMid, 0x8000 );	break;
	}
	return 0;
}

//
// DIO dialog procedure
//
BOOL CALLBACK DioProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	LPARAM	dummy = lParam;
	short	i;

	switch( uMessage ) {
		case WM_CREATE:
			break ;

		case WM_COMMAND:
			dioMenu( hWnd, uMessage, wParam, lParam ); 
			break ;

		case WM_CLOSE:
			for( i = 0; i < MAX_MDL; i++ ) {
				if( hDio[i] == hWnd ) {
					d_init( hWnd );
					hDio[i] = 0;
					break;
				}
			}	
			DestroyWindow( hWnd );
			break;
		case WM_DESTROY:
			break ;
	}
	return 0 ;
}

// G9002̏
DWORD d_init( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = mct110_wIoPortW( hdev, wLno, wMid, 2, 0 );
	
	return dwRet;
}

// DIO޲o
void d_outp( DWORD hDev, WORD wLno, WORD wMid, WORD wPrt )
{
	DWORD dwRet = 0;
	WORD  wData;

	dwRet = mct110_rIoPortW( hDev, wLno, wMid, 2, &wData );
	if( dwRet ) {
		mct_msg( hDev, wLno, wMid, dwRet );
		return;
	}
	wData ^= wPrt;
	dwRet = mct110_wIoPortW( hDev, wLno, wMid, 2,  wData );
	if( dwRet ) {
		mct_msg( hDev, wLno, wMid, dwRet );
	}
}

// DIOӼޭُԓǏo
DWORD d_rprt( DWORD hDev, WORD wLno, WORD wMid, WORD* inp_dt, WORD* out_dt )
{
	DWORD dwRet = 0;
	WORD  prt = 0;

	dwRet |= mct110_rIoPortW( hDev, wLno, wMid, 0, &prt );	// DIO޲͓Ǐo
	*inp_dt = prt;
	dwRet |= mct110_rIoPortW( hDev, wLno, wMid, 2, &prt );	// DIO޲o͓Ǐo
	*out_dt = prt;
	return dwRet;
}

// DIOӼޭُԕ\
void d_disp( HWND hWnd, WORD inp_dt, WORD out_dt )
{
	WORD wPrt;

	wPrt = inp_dt;
	if( wPrt & 1 )	
		SendDlgItemMessage( hWnd, IDC_LI0, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI0, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 2 )	
		SendDlgItemMessage( hWnd, IDC_LI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 4 )	
		SendDlgItemMessage( hWnd, IDC_LI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 8 )	
		SendDlgItemMessage( hWnd, IDC_LI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x10 )	
		SendDlgItemMessage( hWnd, IDC_LI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x20 )	
		SendDlgItemMessage( hWnd, IDC_LI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x40 )	
		SendDlgItemMessage( hWnd, IDC_LI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x80 )	
		SendDlgItemMessage( hWnd, IDC_LI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x100 )	
		SendDlgItemMessage( hWnd, IDC_LI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x200 )	
		SendDlgItemMessage( hWnd, IDC_LI9, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LI9, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x400 )	
		SendDlgItemMessage( hWnd, IDC_LIA, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LIA, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x800 )	
		SendDlgItemMessage( hWnd, IDC_LIB, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LIB, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x1000 )	
		SendDlgItemMessage( hWnd, IDC_LIC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LIC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x2000 )	
		SendDlgItemMessage( hWnd, IDC_LID, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LID, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x4000 )	
		SendDlgItemMessage( hWnd, IDC_LIE, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LIE, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wPrt & 0x8000 )	
		SendDlgItemMessage( hWnd, IDC_LIF, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LIF, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	wPrt = out_dt;
	if( wPrt & 1 )	
		SendDlgItemMessage( hWnd, IDD_LO0, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO0, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 2 )	
		SendDlgItemMessage( hWnd, IDD_LO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 4 )	
		SendDlgItemMessage( hWnd, IDD_LO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 8 )	
		SendDlgItemMessage( hWnd, IDD_LO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x10 )	
		SendDlgItemMessage( hWnd, IDD_LO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x20 )	
		SendDlgItemMessage( hWnd, IDD_LO5, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO5, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x40 )	
		SendDlgItemMessage( hWnd, IDD_LO6, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO6, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x80 )	
		SendDlgItemMessage( hWnd, IDD_LO7, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO7, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x100 )	
		SendDlgItemMessage( hWnd, IDD_LO8, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO8, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x200 )	
		SendDlgItemMessage( hWnd, IDD_LO9, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LO9, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x400 )	
		SendDlgItemMessage( hWnd, IDD_LOA, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LOA, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x800 )	
		SendDlgItemMessage( hWnd, IDD_LOB, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LOB, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x1000 )	
		SendDlgItemMessage( hWnd, IDD_LOC, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LOC, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x2000 )	
		SendDlgItemMessage( hWnd, IDD_LOD, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LOD, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x4000 )	
		SendDlgItemMessage( hWnd, IDD_LOE, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LOE, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wPrt & 0x8000 )	
		SendDlgItemMessage( hWnd, IDD_LOF, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_LOF, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
}
