#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "t1mct00.h"

// x{ݒl(RMG)̌vZ
DWORD cal_rmg( DWORD* dwRmg, WORD wMlt )
{
	DWORD	dwTmp;

	// x{1`50{()
	if(( wMlt < 1 ) || ( 50 < wMlt ))		return ILLEGAL_PARAM; 
	dwTmp = 200 / wMlt - 1;

	if(( dwTmp < 1 ) || ( 2047 < dwTmp ))	return ILLEGAL_PARAM;
	*dwRmg = dwTmp;
											return 0;
}

//
// pos menu
//
LRESULT posMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	WORD	wCmd = 0;
	
	switch( LOWORD( wParam )) {
	case IDD_ML1:		// x{
		if( HIWORD( wParam ) == EN_UPDATE ) {
			update_mlt( hWnd );
		}
		break;
	case IDD_PORG:	// +_A
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STAFL;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STAFH;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = STAUD;
		p_strt( hWnd, 0x10, wCmd, 0 );
		break;	
	case IDD_MORG:	// -_A
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STAFL;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STAFH;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = STAUD;
		p_strt( hWnd, 0x18, wCmd, 0 );
		break;	
	case IDD_PCON:	// {A	
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STAFL;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STAFH;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = STAUD;
		p_strt( hWnd, 0x00, wCmd, 0 );
		break;
	case IDD_MCON:	// |A	
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STAFL;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STAFH;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = STAUD;
		p_strt( hWnd, 0x08, wCmd, 0 );
		break;
	case IDD_PPOS:	// {ʒu	
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STAFL;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STAFH;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = STAUD;
		p_strt( hWnd, 0x41, wCmd, 0 );
		break;	
	case IDD_MPOS:	// |ʒu	
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STAFL;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STAFH;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = STAUD;
		p_strt( hWnd, 0x41, wCmd, 1 );
		break;
	case IDD_STOP:	// ~	
		if( IsDlgButtonChecked( hWnd, ID_RD_FL ) == BST_CHECKED )		wCmd = STOP;
		else if( IsDlgButtonChecked( hWnd, ID_RD_FH ) == BST_CHECKED )	wCmd = STOP;
		else if( IsDlgButtonChecked( hWnd, ID_RD_UD ) == BST_CHECKED )	wCmd = SDSTP;
		p_stop( hWnd, wCmd );	
		break;		
	case IDD_CLR1:		click_cc1( hWnd );		break;	// CTR1ر
	case IDD_CLR2:		click_cc2( hWnd );		break;	// CTR2ر

	case IDD_SVON:		click_svon( hWnd );		break;	// SVONo
	case IDD_SVRS:		click_svrs( hWnd );		break;	// SVRSTo
	case IDD_SVTL:		click_svtl( hWnd );		break;	// SVTLo
	case IDD_SVGN:		click_svgn( hWnd );		break;	// SVGAINo

	case ID_RD_CW:		click_pls( hWnd, 0 );	break;	// wٽo CW/CCW	
	case ID_RD_DIR:		click_pls( hWnd, 1 );	break;	// wٽo PULSE+
	case ID_CHK_ELS:	click_els( hWnd );		break;	// ELS͋ɐI
	case ID_CHK_OLS:	click_ols( hWnd );		break;	// OLS͋ɐI
	case ID_CHK_DLS:	click_dls( hWnd );		break;	// DLS͋ɐI
	case ID_CHK_ALM:	click_alm( hWnd );		break;	// SVALM͋ɐI
	case ID_CHK_INP:	click_inp( hWnd );		break;	// INPOS͋ɐI
	case ID_CHK_IEN:	click_ien( hWnd );		break;	// INPOSL/I
	case ID_CHK_EZ:		click_enz( hWnd );		break;	// ZʹދɐI
	case ID_CHK_RDY:	click_rdy( hWnd );		break;	// SVRDY͋ɐI
	case ID_CHK_CLR:	click_clr( hWnd );		break;	// CLR͋ɐI
	case ID_CHK_LTC:	click_ltc( hWnd );		break;	// LATCH͋ɐI
	}
	return 0;
}

//
// Motion dialog procedure
//
BOOL CALLBACK PosProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	LPARAM	dummy = lParam;
	short	i;

	switch( uMessage ) {
		case WM_CREATE:
			break ;
		case WM_COMMAND:
			posMenu( hWnd, uMessage, wParam, lParam ); 
			break ;
		case WM_CLOSE:
			for( i = 0; i < MAX_MDL; i++ ) {
				if( hPos[i] == hWnd ) {
					p_init( hWnd );
					hPos[i] = 0;
					break;
				}
			}
			DestroyWindow( hWnd );
			break;
		case WM_DESTROY:
			break ;
	}
	return 0 ;
}

// ͋ɐ\
// ߂lF`ڐݒ莞TRUE
//       Faڐݒ莞FALSE
BOOL  pol_disp( HWND hWnd, WPARAM wParam )
{
	if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
		SetDlgItemText( hWnd, wParam, "A" );
		return TRUE;
	} else {
		SetDlgItemText( hWnd, wParam, "B" );
		return FALSE;
	}
}

// ӰӼޭُ
DWORD p_init( HWND hWnd )
{
	DWORD	hdev, dwRet = 0;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet |= h1px_QuickStop( hdev, wLno, wMid );				// ~
	dwRet |= h1px_SetEls( hdev, wLno, wMid, 0, 0 );			// ELS͋ɐݒ	
	dwRet |= h1px_SetOls( hdev, wLno, wMid, 0 );				// OLS͋ɐݒ	
	dwRet |= h1px_SetDls( hdev, wLno, wMid, 1, 0, 0, 0 );	// DLS͋ɐݒ
	dwRet |= h1px_SetSvAlm( hdev, wLno, wMid, 0, 0 );		// SVALM͋ɐݒ	
	dwRet |= h1px_SetInpos( hdev, wLno, wMid, 1, 0 );		// INPOS͋ɐݒ	
	dwRet |= h1px_SetEz( hdev, wLno, wMid, 0, 0 );			// Z͋ɐݒ	
	dwRet |= h1px_SetSvRdy( hdev, wLno, wMid, 0 );			// SVRDY͋ɐݒ	
	dwRet |= h1px_SetClr( hdev, wLno, wMid, 0, 0x7 );		// CLR͋ɐݒ	
	dwRet |= h1px_SetLtc( hdev, wLno, wMid, 0 );				// LTCH͋ɐݒ	
	dwRet |= h1px_SetCmdPulse( hdev, wLno, wMid, 0 );		// pXo͌`ݒ
	dwRet |= h1px_SetSvCtrCl( hdev, wLno, wMid, 1 );			// ΍رo͐ݒ
	dwRet |= h1px_WritCtr( hdev, wLno, wMid, 0, 1 );			// CTR1 clear		
	dwRet |= h1px_WritCtr( hdev, wLno, wMid, 0, 2 );			// CTR2 clear	
	dwRet |= h1px_SvOff( hdev, wLno, wMid );					// SVON OFF
	dwRet |= h1px_SvResetOff( hdev, wLno, wMid );			// SVRST OFF
	dwRet |= h1px_SvTlOff( hdev, wLno, wMid );				// SVTL OFF
	dwRet |= h1px_SvGainOff( hdev, wLno, wMid );				// SVGAIN OFF
	
	return ( dwRet );	
}

// ӰӼޭىʏ
void p_idisp( HWND hWnd )
{
	SetDlgItemInt( hWnd, IDD_RMV, DEF_RMV, TRUE );
	SetDlgItemInt( hWnd, IDD_RFL, DEF_RFL, FALSE );
	SetDlgItemInt( hWnd, IDD_RFH, DEF_RFH, FALSE );
	SetDlgItemInt( hWnd, IDD_RFA, DEF_RFA, FALSE );
	SetDlgItemInt( hWnd, IDD_ACC, DEF_ACC, FALSE );
	SetDlgItemInt( hWnd, IDD_DEC, DEF_DEC, FALSE );
	SetDlgItemInt( hWnd, IDD_CMP, DEF_RCMP3, FALSE );
	SetDlgItemInt( hWnd, IDD_ML1, 1, FALSE );
	SetDlgItemInt( hWnd, IDD_ML2, 1, FALSE );
	SetDlgItemInt( hWnd, IDD_ML3, 1, FALSE );
	SetDlgItemInt( hWnd, IDD_MOD, 1, FALSE );
	CheckDlgButton( hWnd, ID_CHK_IEN, BST_CHECKED );
	CheckDlgButton( hWnd, ID_RD_FL, BST_CHECKED );
	CheckDlgButton( hWnd, ID_RD_FH, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_UD, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_CW, BST_CHECKED );
	CheckDlgButton( hWnd, ID_RD_DIR, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_CTR1, BST_CHECKED );
	CheckDlgButton( hWnd, ID_RD_CTR2, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_CMP1, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_CMP2, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_CMP3, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_RD_CMP4, BST_CHECKED );
}

// ӰӼޭٽðǏo
DWORD p_rsts( MDL_INFO hPmd, P_STS* p )
{
	DWORD dwRet = 0;
	long  lCtr = 0;
	DWORD dwSpd = 0, dwSts;
	BYTE  byData = 0;

	dwRet |= h1px_ReadExSts( hPmd.dev, hPmd.lno, hPmd.mid, &dwSts );		// gðǏo
	p->rsts = dwSts;
	dwRet |= h1px_ReadCtr( hPmd.dev, hPmd.lno, hPmd.mid, 1, &lCtr );		// 1Ǐo
	p->ctr1 = lCtr;
	dwRet |= h1px_ReadCtr( hPmd.dev, hPmd.lno, hPmd.mid, 2, &lCtr );		// 2Ǐo
	p->ctr2 = lCtr;
	dwRet |= h1px_ReadSpd( hPmd.dev, hPmd.lno, hPmd.mid, &dwSpd );		// wߑxǏo
	p->rspd = dwSpd;	
	dwRet |= h1px_ReadOutp( hPmd.dev, hPmd.lno, hPmd.mid, &byData );		// o߰ēǏo
	p->outp = byData;

	return ( dwRet );
}

// ӰӼޭُԕ\
void p_disp( HWND hWnd, P_STS p, WORD mlt )
{
	DWORD	sts = p.rsts;
	DWORD	spd = p.rspd * mlt;
	long	ct1 = p.ctr1;
	long	ct2 = p.ctr2;
	BYTE	prt = p.outp;

	sts = p.rsts;
	if( sts & 0x0020 )	
		SendDlgItemMessage( hWnd, IDC_ALM, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_ALM, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x0040 )	
		SendDlgItemMessage( hWnd, IDC_PEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_PEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x0080 )	
		SendDlgItemMessage( hWnd, IDC_MEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_MEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x0100 )	
		SendDlgItemMessage( hWnd, IDC_OLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_OLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x0200 )	
		SendDlgItemMessage( hWnd, IDC_DLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_DLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x4000 )	
		SendDlgItemMessage( hWnd, IDC_RDY, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_RDY, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x10000 )	
		SendDlgItemMessage( hWnd, IDC_EZ, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_EZ, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x20000 )	
		SendDlgItemMessage( hWnd, IDC_CLR, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_CLR, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x40000 )	
		SendDlgItemMessage( hWnd, IDC_LTC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_LTC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( sts & 0x80000 )	
		SendDlgItemMessage( hWnd, IDC_INP, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_INP, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	
	if( sts & 0x400000 )	
		SendDlgItemMessage( hWnd, IDC_CMP, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_CMP, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( prt & 0x0001 )	
		SendDlgItemMessage( hWnd, IDC_SON, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_SON, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( prt & 0x0002 )	
		SendDlgItemMessage( hWnd, IDC_SRS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_SRS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( prt & 0x0004 )	
		SendDlgItemMessage( hWnd, IDC_STL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_STL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( prt & 0x0008 )	
		SendDlgItemMessage( hWnd, IDC_SGN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_SGN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	SetDlgItemInt( hWnd, IDD_CTR1, ct1, TRUE );
	SetDlgItemInt( hWnd, IDD_CTR2, ct2, TRUE );
	SetDlgItemInt( hWnd, IDD_SPD,  spd, FALSE );
}

// ELS͋ɐݒ	
void click_els( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_ELS;
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetEls( hdev, wLno, wMid, 1, 0 );  
	} else {							// a
		dwRet = h1px_SetEls( hdev, wLno, wMid, 0, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );	
		return;
	}
}

// OLS͋ɐݒ
void click_ols( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_OLS;	
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetOls( hdev, wLno, wMid, 1 );  
	} else {							// a
		dwRet = h1px_SetOls( hdev, wLno, wMid, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}		

// DLS͋ɐݒ				
void click_dls( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_DLS;
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetDls( hdev, wLno, wMid, 1, 1, 0, 0 );  
	} else {							// a
		dwRet = h1px_SetDls( hdev, wLno, wMid, 1, 0, 0, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}


// SVALM͋ɐݒ
void click_alm( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_ALM;
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;
	
	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetSvAlm( hdev, wLno, wMid, 1, 0 );  
	} else {							// a
		dwRet = h1px_SetSvAlm( hdev, wLno, wMid, 0, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}

// INPOS͋ɐݒ					
void click_inp( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_INP;
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid, enb;
	
	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( IsDlgButtonChecked( hWnd, ID_CHK_IEN ) == BST_CHECKED ) {
		enb = 1;
	} else {
		enb = 0;
	}
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetInpos( hdev, wLno, wMid, enb, 1 );  
	} else {							// a
		dwRet = h1px_SetInpos( hdev, wLno, wMid, enb, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}

// Z͋ɐݒ					
void click_enz( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_EZ;		
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;
	
	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetEz( hdev, wLno, wMid, 0, 1 );  
	} else {							// a
		dwRet = h1px_SetEz( hdev, wLno, wMid, 0, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}


// SVRDY͋ɐݒ					
void click_rdy( HWND hWnd )
{
	WPARAM wParam = ID_CHK_RDY;		
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetSvRdy( hdev, wLno, wMid, 1 );  
	} else {							// a
		dwRet = h1px_SetSvRdy( hdev, wLno, wMid, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}

// INPOSL/ݒ					
void click_ien( HWND hWnd )
{
	WPARAM	wParam = ID_CHK_INP;
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid, enb, pol;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( IsDlgButtonChecked( hWnd, ID_CHK_INP ) == BST_CHECKED ) pol = 1;
	else														pol = 0;	
	if( IsDlgButtonChecked( hWnd, ID_CHK_IEN ) == BST_CHECKED ) enb = 1;
	else														enb = 0;	

	dwRet = h1px_SetInpos( hdev, wLno, wMid, enb, pol );
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}	

// CLR͋ɐݒ
void click_clr( HWND hWnd ) 
{
	WPARAM	wParam = ID_CHK_CLR;		
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetClr( hdev, wLno, wMid, 1, 0x7 );  
	} else {							// a
		dwRet = h1px_SetClr( hdev, wLno, wMid, 0, 0x7 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}

// LTCH͋ɐݒ
void click_ltc( HWND hWnd ) 
{
	WPARAM	wParam = ID_CHK_LTC;	
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno, wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	if( pol_disp( hWnd, wParam ) ) {	// `
		dwRet = h1px_SetLtc( hdev, wLno, wMid, 1 );  
	} else {							// a
		dwRet = h1px_SetLtc( hdev, wLno, wMid, 0 );  
	}
	if( dwRet ) {
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}
}				
			

// G9003ڼ޽ݒ
DWORD p_sreg( HWND hWnd, WORD wDir )
{
	DWORD	dwRfl, dwRfh, dwRur, dwRdr, dwAcc, dwDec, dwRmg, 
			dwRfa, dwTmp = 0, dwRet = 0, hdev;
	long	lDst, lCmp;
	WORD	wMlt, wMod, wCon, wCtr, wLno, wMid;
	BOOL	b;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	lDst = GetDlgItemInt( hWnd, IDD_RMV, &b, FALSE );				// ړʎ擾
	if( wDir == 1 ) {	// -ʒu
		lDst = (-lDst);
	}
	dwRfl = GetDlgItemInt( hWnd, IDD_RFL, &b, FALSE );				// x[Xx擾
	dwRfh = GetDlgItemInt( hWnd, IDD_RFH, &b, FALSE );				// 쑬x擾
	dwRfa = GetDlgItemInt( hWnd, IDD_RFA, &b, FALSE );				// ⏕x擾


	wMlt = GetDlgItemInt( hWnd, IDD_ML1, &b, FALSE );				// x{擾
	if( wMlt == 0 )							return ILLEGAL_PARAM;
	if( 50 < wMlt ) 						return ILLEGAL_PARAM;
	dwRet = cal_rmg( &dwRmg, wMlt );								// x{ݒlvZ
	if( dwRet ) 							return dwRet;
	
	dwAcc = GetDlgItemInt( hWnd, IDD_ACC, &b, FALSE );				// Ԏ擾
	dwDec = GetDlgItemInt( hWnd, IDD_DEC, &b, FALSE );				// Ԏ擾
	if(( dwAcc * 2 ) < dwDec )				return ILLEGAL_PARAM;
	dwRet = h1px_CalAccRate(&dwRur,dwAcc,dwRfh,dwRfl,0,0);			// ڰČvZ
	if( dwRet ) 							return dwRet;
	if( dwDec == 0 ) {
		dwRet = h1px_SetAutoDec( hdev, wLno, wMid, 1 );				// Jn_蓮ݒ
		if( dwRet ) 						return dwRet;
		dwRet = h1px_SetDecPoint( hdev, wLno, wMid, 0 );				// Jn_0ɐݒ()
		if( dwRet ) 						return dwRet;
		dwRdr = 0;
	} else {
		dwRet = h1px_SetAutoDec( hdev, wLno, wMid, 0 );				// Jn_ݒ
		if( dwRet ) 						return dwRet;
		dwRet = h1px_CalAccRate(&dwRdr,dwDec,dwRfh,dwRfl,0,0);		// ڰČvZ
		if( dwRet ) 						return dwRet;
	}
	
	lCmp = GetDlgItemInt( hWnd, IDD_CMP, &b, TRUE );				// Rp[^rf[^擾
	wMod = GetDlgItemInt( hWnd, IDD_MOD, &b, FALSE );				// _A[h擾

	dwRet = h1px_WritPos   ( hdev, wLno, wMid, lDst );				// ړʐݒ
	if( dwRet ) 							return dwRet;
	dwRet = h1px_SetFLSpd  ( hdev, wLno, wMid, dwRfl );				// x[Xxݒ
	if( dwRet ) 							return dwRet;
	dwRet = h1px_WritFHSpd ( hdev, wLno, wMid, dwRfh );				// 쑬xݒ
	if( dwRet ) 							return dwRet;
	dwRet = h1px_SetAuxSpd ( hdev, wLno, wMid, dwRfa );				// ⏕xݒ
	if( dwRet ) 							return dwRet;
	dwRet = h1px_SetAccRate( hdev, wLno, wMid, dwRur );				// [gݒ
	if( dwRet ) 							return dwRet;
	dwRet = h1px_SetDecRate( hdev, wLno, wMid, dwRdr );				// [gݒ
	if( dwRet ) 							return dwRet;
	dwRet = h1px_SetMult   ( hdev, wLno, wMid, dwRmg );				// x{ݒ背WX^
	if( dwRet ) 							return dwRet;
	dwRet = h1px_SetOrgMode( hdev, wLno, wMid, wMod );				// _A[hݒ
	if( dwRet ) 							return dwRet;
	
	// ڰr擾
	if( IsDlgButtonChecked( hWnd, ID_RD_CTR1 ) == BST_CHECKED )	{
		wCtr = 0;
	} else if( IsDlgButtonChecked( hWnd, ID_RD_CTR2 ) == BST_CHECKED ) {
		wCtr = 1;
	} else {
		wCtr = 0;
	}

	// ڰr擾
	if( IsDlgButtonChecked( hWnd, ID_RD_CMP1 ) == BST_CHECKED )	{			// ڰrް=r(ĕ֌W)
		wCon = 1;
	} else if( IsDlgButtonChecked( hWnd, ID_RD_CMP2 ) == BST_CHECKED ) {	// ڰrް>r@
		wCon = 4;	
	} else if( IsDlgButtonChecked( hWnd, ID_RD_CMP3 ) == BST_CHECKED ) {	// ڰrް<r
		wCon = 5;
	} else {
		wCon = 0;
	}
	dwRet = h1px_SetCmp( hdev, wLno, wMid, wCtr, wCon, 0, lCmp );	// ڰ3ݒ

	return dwRet;
}


// X^[g
void p_strt( HWND hWnd, WORD wMode, WORD wCmd, WORD wDir )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = p_sreg( hWnd, wDir );
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}

	dwRet = h1px_WritOpeMode( hdev, wLno, wMid, wMode );
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}

	dwRet = mct110_wPclCmd( hdev, wLno, wMid, wCmd ); 
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
		return;
	}

	ctl_enbl( hWnd, FALSE );	// ۰َgps
}

// ~	
void p_stop( HWND hWnd, WORD wCmd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;
	
	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = mct110_wPclCmd( hdev, wLno, wMid, wCmd ); 
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}

// CTR1 clear
void click_cc1( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;
	
	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_WritCtr( hdev, wLno, wMid, 0, 1 ); 
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}

// CTR2 clear			
void click_cc2( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_WritCtr( hdev, wLno, wMid, 0, 2 ); 
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}
	
// svon output(onȂoff, offȂon)
void click_svon( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;
	BYTE	byData;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_ReadOutp( hdev, wLno, wMid, &byData );	// o߰ēǏo
	if( byData & 0x0001 ) {								// SVON ONȂ	
		dwRet = h1px_SvOff( hdev, wLno, wMid );			// SVON OFF
	} else {											// SVON OFFȂ					
		dwRet = h1px_SvOn( hdev, wLno, wMid );			// SVON ON
	}			
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}

// svrst output(onȂoff, offȂon)	
void click_svrs( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;
	BYTE	byData;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_ReadOutp( hdev, wLno, wMid, &byData );	// o߰ēǏo
	if( byData & 0x0002 ) {								// SVRST ONȂ	
		dwRet = h1px_SvResetOff( hdev, wLno, wMid );			// SVRST OFF
	} else {											// SVRST OFFȂ					
		dwRet = h1px_SvResetOn( hdev, wLno, wMid );			// SVRST ON
	}			
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}

// svtl output(onȂoff, offȂon)	
void click_svtl( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;
	BYTE	byData;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_ReadOutp( hdev, wLno, wMid, &byData );	// o߰ēǏo
	if( byData & 0x0004 ) {								// SVTL ONȂ	
		dwRet = h1px_SvTlOff( hdev, wLno, wMid );			// SVTL OFF
	} else {											// SVTL OFFȂ					
		dwRet = h1px_SvTlOn( hdev, wLno, wMid );				// SVTL ON
	}			
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}

// svgain output(onȂoff, offȂon)	
void click_svgn( HWND hWnd )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;
	BYTE	byData;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_ReadOutp( hdev, wLno, wMid, &byData );	// o߰ēǏo
	if( byData & 0x0008 ) {								// SVGAIN ONȂ	
		dwRet = h1px_SvGainOff( hdev, wLno, wMid );			// SVGAIN OFF
	} else {											// SVGAIN OFFȂ					
		dwRet = h1px_SvGainOn( hdev, wLno, wMid );				// SVGAIN ON
	}			
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}

// w߃pXo͌`ݒ
void click_pls( HWND hWnd, WORD wPrm )
{
	DWORD	dwRet = 0;
	DWORD	hdev;
	WORD	wLno,
			wMid;

	get_m_info( hWnd, &hdev, &wLno, &wMid );
	dwRet = h1px_SetCmdPulse( hdev, wLno, wMid, wPrm );
	if( dwRet )	{
		mct_msg( hdev, wLno, wMid, dwRet );
	}
}
	
// {ݒGfBbgBOXXV
void  update_mlt( HWND hWnd )
{
	DWORD	dwRet = 0;
	WORD	wIx;
	DWORD	hdev;
	WORD	wLno,
			wMid,
			wMlt;
	BOOL	b;

	for( wIx = 0; wIx < MAX_MDL; wIx++ ) {
		if( hPos[wIx] == hWnd ) {
			hdev = gPmdl[wIx].dev;
			wLno = gPmdl[wIx].lno;
			wMid = gPmdl[wIx].mid;
			break;
		}
	}
	
	wMlt = GetDlgItemInt( hWnd, IDD_ML1, &b, FALSE );
	if( 50 < wMlt ) {
		MessageBox( NULL, "۸тł͑x{50{ȉŐݒ肵ĂB", "", MB_OK );
		SetDlgItemInt( hWnd, IDD_ML1, gMlt[wIx], FALSE );
	} else {
		gMlt[wIx] = wMlt;
		SetDlgItemInt( hWnd, IDD_ML2, gMlt[wIx], FALSE );
		SetDlgItemInt( hWnd, IDD_ML3, gMlt[wIx], FALSE );
	}
}			

// Rg[gp^s؂ւ
void ctl_enbl( HWND hWnd, BOOL bFlag )
{
	EnableWindow( GetDlgItem( hWnd, IDD_PORG ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_MORG ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_PCON ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_MCON ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_PPOS ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_MPOS ), bFlag );

	EnableWindow( GetDlgItem( hWnd, ID_RD_FL ),  bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_FH ),  bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_UD ),  bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CW ),  bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_DIR ), bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CTR1 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CTR2 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CMP1 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CMP2 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CMP3 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, ID_RD_CMP4 ), bFlag );

	EnableWindow( GetDlgItem( hWnd, IDD_RMV ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_RFH ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_RFL ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_RFA ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_ACC ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_DEC ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_CMP ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_MOD ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_ML1 ), bFlag );
}