//
// Progmain.c
//

#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "t1mct00.h"

#define NUMBUTTONS	2					// °ްݐ
#define NUMPARTS	3					// ðް

HINSTANCE	gInst;						// ݽݽ
HWND		gWnd;						// Ҳ޲۸
HWND		hStatus;					// ðް
int			parts[NUMPARTS];			// ðް

HMENU		hMenu  = NULL;
HMENU		hSub = NULL;
HWND		tbWnd;						// °ް̃nh
TBBUTTON	tbBtn[NUMBUTTONS];			// c[{^

DWORD		IsPulseOut( DWORD, WORD );	// w肵ײ݂ɐڑꂽӼޭقٽo͒mF

//	 16i̒lϊ
//	pszStr | 	
//	pdwVal | l	
void htol(char* pszStr, DWORD* pdwVal)
{
	DWORD	dwVal = 0;
	char*	pszW;

	pszW = pszStr;
	while(*pszW) {
		if	   (*pszW >= '0' && *pszW <= '9') dwVal = (dwVal * 0x10)+(*pszW - '0');
		else if(*pszW >= 'a' && *pszW <= 'f') dwVal = (dwVal * 0x10)+((*pszW - 'a') + 10);
		else if(*pszW >= 'A' && *pszW <= 'F') dwVal = (dwVal * 0x10)+((*pszW - 'A') + 10);
		else	break;
		pszW++;
	}
	(*pdwVal) = dwVal;
	return;
}

// °ް
void init_toolbar( HINSTANCE hInst, HWND hWnd )
{
	tbBtn[0].iBitmap = 0;
	tbBtn[0].idCommand = IDM_STA1;
	tbBtn[0].fsState = TBSTATE_ENABLED;
	tbBtn[0].fsStyle = TBSTYLE_CHECKGROUP;
	tbBtn[0].dwData  = 0;
	tbBtn[0].iBitmap = 0;
	tbBtn[0].iString = 0;

	tbBtn[1].iBitmap = 1;
	tbBtn[1].idCommand = IDM_STP1;
	tbBtn[1].fsState = TBSTATE_ENABLED;
	tbBtn[1].fsStyle = TBSTYLE_CHECKGROUP;
	tbBtn[1].dwData  = 0;
	tbBtn[1].iString = 0;

	tbWnd = CreateToolbarEx(hWnd,
					   WS_VISIBLE | WS_CHILD | WS_BORDER,
					   IDM_TOOLBAR,
					   NUMBUTTONS,
					   hInst,
					   IDTB_BMP,
					   tbBtn,
					   NUMBUTTONS,
					   16, 16, 16, 16,
					   sizeof(TBBUTTON));
	
	SendMessage(tbWnd, TB_ENABLEBUTTON, (LPARAM)IDM_STP1, (WPARAM)FALSE);
	ShowWindow(tbWnd, SW_HIDE);
}

// Xe[^XEBhE
void init_statusbar( HWND hWnd )
{
	RECT WinDim;
	int i;

	GetClientRect( hWnd, &WinDim );

	for( i = 1; i <= NUMPARTS; i++ ) {
		parts[i-1] = WinDim.right / NUMPARTS * i;
	}

	parts[0] = parts[0] * 9 / 10;
	parts[1] = parts[1] * 9 / 10;

	// Xe[^XEBhE쐬
	hStatus = CreateWindow( STATUSCLASSNAME,
							   "",
							   WS_CHILD | WS_VISIBLE, 
							   0, 0, 0, 0,
							   hWnd,
							   NULL,
							   gInst,
							   NULL );

	SendMessage( hStatus, SB_SETPARTS, (WPARAM)NUMPARTS, (LPARAM)parts );
}

// O[oϐ
void init_global( void )
{
	WORD wIx;
	
	for( wIx = 0; wIx < MAX_MDL; wIx++ ) {
		hPos[wIx] = 0;
		hDio[wIx] = 0;
	}
	for( wIx = 0; wIx < MAX_BRD; wIx++ ) {
		hMct[wIx] = ILL_HNDL;	// MCAT޲
	}

	for( wIx = 0; wIx < MAX_MDL; wIx++ ) {
		gMlt[wIx] = 1;			// x{
	}
	hUse = ILL_HNDL;			// MCAT޲
}

// MCAT޲擾 & open
DWORD init_mcat( void )
{
	DWORD	dwRet = 0;

	dwRet = h1px_GetDevInfo( &gCnt, &gInf[0] );
	if( dwRet ) {
		MessageBox( NULL, "foCX񂪎擾ł܂.", "", MB_OK );
	}
	return dwRet;
}

// MCAT {[h̏I
DWORD close_mct( void )
{
	DWORD	dwRet = 0;
	WORD	wIx;
	
	for( wIx = 0; wIx < MAX_BRD; wIx++ ) {
		if( hMct[wIx] != ILL_HNDL ) {
			dwRet |= mct110_wCenCmd( hMct[wIx], 0, 0x2004 );	// ײ1̑SӰӼޭؾ
			dwRet |= mct110_wCenCmd( hMct[wIx], 1, 0x2004 );	// ײ2̑SӰӼޭؾ

			dwRet |= mct110_wOptPortW( hMct[wIx], 2,  0 );	// MCATėpoOFF
			dwRet |= h1px_DevClose( hMct[wIx] );				// ۰ޏ
			hMct[wIx] = ILL_HNDL;
		}
	}
	return dwRet;
}

// initialize
void userInit( HWND hWnd )
{
	DWORD	dwRet = 0;
	static HMENU hPopBid, hPopDev;

	init_statusbar( hWnd );
	init_toolbar( gInst, hWnd );
	hWht = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_WHT) );
	hGrn = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_GRN) );
	hRed = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_RED) );
	init_global();		// ۰ٕϐ
	SendDlgItemMessage( hWnd, ID_CMB_LIN1P, CB_SETCURSEL, 0, 0 );
	SendDlgItemMessage( hWnd, ID_CMB_LIN1D, CB_SETCURSEL, 0, 0 );
	SetDlgItemText( hWnd, IDC_ADRS, "980" );
	CheckDlgButton( hWnd, IDR_IOACC, BST_CHECKED );
	CheckDlgButton( hWnd, IDR_8BYTE, BST_CHECKED );

	dwRet = init_mcat();
}

// VXeʐM
DWORD mct_ssys( DWORD hDev, WORD wLno )
{
	DWORD	dwRet = 0;
	WORD	wSts,
			wTimeOut;

	// VXeʐM	
	dwRet = mct110_wCenCmd( hDev, wLno, 0x1000 );		// ђʐM
	if( dwRet )		return dwRet;
	// ђʐM҂
	wSts = 0;
	wTimeOut=1000;
	while((wSts & 1) == 0) {
		dwRet = mct110_rCenMsts( hDev, wLno, &wSts );
		if( dwRet ) {
			return dwRet;
		} else {
			if( wSts & 0x10 ) {							// ђʐMװ
				return COM_OTHER_ERROR;
			} else if( wSts & 0x40 ) {					// ђʐMɒʐMs
				return ILL_ACCESS_COM;
			} else {
				Sleep(1);
				wTimeOut--;
				if(wTimeOut==0) {
					return COM_OTHER_ERROR;	
				}
			}
		}
	}
	return (0);
}

// دʐMJn
void mct_csta( DWORD hDev, WORD wLno )
{
	DWORD	dwRet = 0;
	WORD	wSts,
			wTimeOut;

	// دʐMJn
	dwRet = mct110_wCenCmd( hDev, wLno, 0x3000 );
	if( dwRet )	{
		mct_msg( hDev, wLno, 0, dwRet );
		return;
	}

	// دʐMJn҂
	wSts = 0;
	wTimeOut=1000;
	while((wSts & 0x1000) == 0) {
		dwRet = mct110_rCenMsts( hDev, wLno, &wSts );
		if( dwRet ) {
			mct_msg( hDev, wLno, 0, dwRet );
			return;
		} else {
			Sleep( 1 );
			if( wSts & 0x0008 ) {									// دʐMװ				
				mct_msg( hDev, wLno, 0, CYC_COM_ERROR );
				return;
			} else if( wSts & 0x40 ) {
				mct_msg( hDev, wLno, 0, ILL_ACCESS_COM );
				return;
			} else {
				Sleep(1);
				wTimeOut--;
				if(wTimeOut==0) {
					mct_msg( hDev, wLno, 0, COM_OTHER_ERROR );
					return;	
				}
			}
		}
	}
	return;
}

// دʐM~
void mct_cstp( DWORD hDev, WORD wLno )
{
	DWORD	dwRet = 0;
	WORD	wSts,
			wTimeOut;	

	dwRet = mct110_rCenMsts( hDev, wLno, &wSts );
	if(dwRet) {
		mct_msg( hDev, wLno, 0, dwRet );
		return;
	}
	if( wSts & 0x1000 ) {	// دʐM
		dwRet = mct110_wCenCmd( hDev, wLno, 0x3100 );
		if(dwRet) {
			mct_msg( hDev, wLno, 0, dwRet );
			return;
		}
		dwRet = mct110_rCenMsts( hDev, wLno, &wSts );
		if(dwRet) {
			mct_msg( hDev, wLno, 0, dwRet );
			return;
		}
		wTimeOut = 1000;
		while( wSts & 0x1000 ) {
			dwRet = mct110_rCenMsts( hDev, wLno, &wSts );
			if(dwRet) {
				mct_msg( hDev, wLno, 0, dwRet );
				return;
			} else {
				Sleep(1);
				wTimeOut--;
				if(wTimeOut==0) {
					mct_msg( hDev, wLno, 0, COM_OTHER_ERROR );
					return;	
				}
			}
			if( wSts & 0x0008 ) {		// دʐMװ
				mct_msg( hDev, wLno, 0, CYC_COM_ERROR );
				return;
			}
		}
	}
	return;
}

// دʐMxǏo
DWORD mct_rcyc( DWORD hDev, WORD wLno, WORD* wSpd )
{
	DWORD	dwRet = 0;
	WORD	wReg = 0,
			wSts;

	dwRet |= mct110_rCenMsts( hDev, wLno, &wSts );
	if( wSts & 0x1000 ) {
		if( wSts & 0x0008 ) {
			mct_msg( hDev, wLno, 0, CYC_COM_ERROR );
			*wSpd = 0;
		}
		dwRet |= mct110_wCenCmd( hDev, wLno, 0x6502 );	// دʐMԓǏo	
		dwRet |= mct110_rCenBuf( hDev, wLno, &wReg );	// oޯ̧Ǐo
		*wSpd = wReg;
	} else {			
		*wSpd = 0;
	}
	return (dwRet);
}

// ėp͏ԓǏo
DWORD mct_rinp( DWORD hDev, WORD* wPrt )
{
	DWORD dwRet = 0;
	WORD  wData = 0;

	if(gUse.dwAccessMode){
	// 8byte[h
		dwRet |= mct110_rOptPortW( hDev, 0x10, &wData );	// ėp̓|[gǏo
	}else{
	// 512byte[h
		dwRet |= mct110_rOptPortW( hDev, 0x200, &wData );	// ėp̓|[gǏo
	}
	*wPrt = wData;
	return (dwRet);
}

// ėpo͏ԓǏo
DWORD mct_rout( DWORD hDev, WORD* wPrt )
{
	DWORD dwRet = 0;
	WORD  wData = 0;

	if(gUse.dwAccessMode){
	// 8byte[h
		dwRet |= mct110_rOptPortW( hDev, 0x12, &wData );	// ėpo̓|[gǏo
	}else{
	// 512byte[h
		dwRet |= mct110_rOptPortW( hDev, 0x202, &wData );	// ėpo̓|[gǏo
	}
	*wPrt = wData;	
	return ( dwRet );
}

// ėpo
DWORD mct_wout( DWORD hDev, WORD wPrt )
{
	DWORD dwRet = 0;
	WORD  wData = 0;

	if(gUse.dwAccessMode){
	// 8byte[h
		dwRet |= mct110_rOptPortW( hDev, 0x12, &wData );
		wPrt ^= wData;
		dwRet |= mct110_wOptPortW( hDev, 0x12,  wPrt );	
	}else{
	// 512byte[h
		dwRet |= mct110_rOptPortW( hDev, 0x202, &wData );
		wPrt ^= wData;
		dwRet |= mct110_wOptPortW( hDev, 0x202,  wPrt );	
	}
	return ( dwRet );
}

// ʐMxǏo
DWORD mct_rspd( DWORD hDev, WORD* wPrt )
{
	DWORD dwRet = 0;
	WORD  wData = 0;

	dwRet |= mct110_rOptPortW( hDev, 0x6, &wData );	// ʐMxmF|[gǏo
	*wPrt = wData;
	return ( dwRet );
}

// ޲\
void  inf_disp( HWND hWnd, WORD wIndex )
{
	char	szBuf[256];

	// foCX\
	wsprintf( szBuf, "%s\r\n%s%d\r\n%s%08xh\r\n%s%d\r\n%s%d\r\n%s%d\r\n%s%d",	
			"** Device Information **",
			"Bus :", gInf[wIndex].dwBusNumber,
			"BAR :", gInf[wIndex].dwBaseAddress,
			"Spc :", gInf[wIndex].dwAddressSpace,
			"IRQ :", gInf[wIndex].dwIrqNo,
			"No  :", gInf[wIndex].dwNumber,
			"Mode:", gInf[wIndex].dwAccessMode
			);
	SetDlgItemText( hWnd, IDC_DEVINFO, szBuf );
}

// ʐMx\
void  spd_disp( HWND hWnd )
{
	char	szBuf0[32], szBuf1[32];
	WORD	wData;
	DWORD	dwRet = 0;

	strcpy( szBuf0, "ʐMxݒl:" );
	dwRet = mct_rspd( hUse, &wData );
	if( dwRet ) {
		mct_msg( hUse, 0, 0, dwRet );
		return;
	}
	wData &= 0x000c;
	if( wData == 0x0000 )		wsprintf( szBuf1, "20Mbps" );
	else if( wData == 0x0004 )	wsprintf( szBuf1, "5Mbps" );
	else if( wData == 0x0008 )	wsprintf( szBuf1, "10Mbps" );
	else if( wData == 0x000c )	wsprintf( szBuf1, "2.5Mbps" );
	strcat( szBuf0, szBuf1 );
	SendMessage(hStatus, SB_SETTEXT, (WPARAM) 2, (LPARAM)szBuf0 );
}

// دʐM\
void  cyc_disp( HWND hWnd )
{
	char	szBuf[256], szTmp[64];
	WORD	wSpd;
	DWORD	dwRet = 0;

	// ײ1دʐMǏo
	dwRet = mct_rcyc( hUse, 0, &wSpd );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		mct_msg( hUse, 0, 0, dwRet );
		return;
	}
	if( wSpd != 0 ) {
		SendMessage(tbWnd, TB_ENABLEBUTTON, (LPARAM)IDM_STA1, (WPARAM)FALSE);
		SendMessage(tbWnd, TB_ENABLEBUTTON, (LPARAM)IDM_STP1, (WPARAM)TRUE);
		itoa( wSpd, szTmp, 10 );
		strcpy( szBuf, "Line1:" );
		strcat( szBuf, szTmp );
		strcat( szBuf, "us" );
	} else {
		SendMessage(tbWnd, TB_ENABLEBUTTON, (LPARAM)IDM_STA1, (WPARAM)TRUE);
		SendMessage(tbWnd, TB_ENABLEBUTTON, (LPARAM)IDM_STP1, (WPARAM)FALSE);
		strcpy( szBuf, "دʐM~" );
	}
	SendMessage(hStatus, SB_SETTEXT, (WPARAM) 0, (LPARAM)szBuf );
}	

// _CAOnh烂[VW[̃foCXnhCCԍCW[ID擾
void get_m_info( HWND hWnd, DWORD* hDev, WORD* wLno, WORD* wMid )
{
	WORD	wIx;

	for( wIx = 0; wIx < MAX_MDL; wIx++ ) {
		if( hPos[wIx] == hWnd ) {
			*hDev = gPmdl[wIx].dev;
			*wLno = gPmdl[wIx].lno;
			*wMid = gPmdl[wIx].mid;
			break;
		}
		if( hDio[wIx] == hWnd ) {
			*hDev = gDmdl[wIx].dev;
			*wLno = gDmdl[wIx].lno;
			*wMid = gDmdl[wIx].mid;
			break;
		}
	}
}

// w肵ײ݂ɐڑꂽӼޭقٽo͒mF
//	߂l
//		0:ٽo͂ĂȂ
//		1:ٽo͒
//		2:̴̑װ			
DWORD IsPulseOut( DWORD hDev, WORD wLno )
{
	DWORD	dwRet = 0,
			dwFlg = 0;
	WORD	wMid,
			wMst;
	BYTE	byData;
	
	for(wMid=0; wMid<MAX_MDL; wMid++) {
		dwRet = mct110_rLclInfo( hDev, wLno, wMid, &byData );	// ۰޲Ǐo
		if( dwRet )	{
			mct_msg( hDev, wLno, wMid, dwRet );
			return (2);
		}
		if( byData & 0x80 ) {
			if( byData & 0x8 ) {	// Motion
				dwRet = h1px_ReadMainSts( hDev, wLno, wMid, &wMst );
				if( dwRet ) {
					mct_msg( hDev, wLno, wMid, dwRet );
					return (2);
				} else {
					if( wMst & 0x0100 ) {	// ٽo͒
						dwFlg |= 1;
					}
				}
			}
		}

	}
	return (dwFlg);
}
	
			
//
// register main window calss
//
BOOL InitApplication( HINSTANCE hInstance )
{
	WNDCLASSEX  wc ;

	if( hInstance )	{
		// EBhENX`
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			// EBhE̎(TCYύXĕ`)
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					// EChE֐̃AhX
		wc.cbClsExtra	 =	0;									// ̑̃NX
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						// ̑̃EBhE
		wc.hInstance	 =	hInstance;							// ̃CX^X̃nh
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	// WACR̃nh
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		// }EXJ[\̃nh
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		// EBhE̔wiF({^̕\ʂ̉e)
		wc.lpszMenuName	 =	"MENU";								// Cj[̖O
		wc.lpszClassName =	"MAIN";								// EBhENX̖O
		wc.cbSize		 =	sizeof(WNDCLASSEX);					// WNDCLASSEX\̂̃TCYݒ
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		// X[ACR		
	}
	return( RegisterClassEx(&wc) ) ;							// WNDCLASS̓o^
}

//
// careate main window
//
HWND InitInstance( HINSTANCE hInstance, int nCmdShow )
{
	HWND hWnd ;

	hWnd = CreateDialog( hInstance, "MAIN", 0, NULL ) ;

	if( hWnd != NULL ) {
		ShowWindow( hWnd, nCmdShow ) ;
		UpdateWindow( hWnd ) ;
	}
	return hWnd ;
}


//
// WinMain
//
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,	LPSTR lpCmdLine, int nCmdShow )
{
	MSG						msg;
	HWND					hWnd;
	INITCOMMONCONTROLSEX	cc;

	// register main window class
	if(!InitApplication(hInstance))					return FALSE;

	// create main window
	if(!(hWnd = InitInstance(hInstance, nCmdShow)))	return FALSE;

	// RRg[
	InitCommonControlsEx( &cc ); 
	cc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	cc.dwICC = ICC_UPDOWN_CLASS | ICC_BAR_CLASSES;

	gWnd  = hWnd;
	gInst = hInstance;
	hMenu = GetMenu( hWnd );
	hSub  = GetSubMenu( hMenu, 0 );
	userInit( hWnd );
		
	// dispatch messages
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(!IsDialogMessage( hWnd, &msg )) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	return msg.wParam;
}

//
// user menu
//
LRESULT userMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	char	szBuf[256];
	int		index, nAns;
	DWORD	dwAdr, dwMid, dwSpc, dwMode;
	WORD	wIx;
	DWORD	dwIx, dwRet;

	switch( LOWORD( wParam )) {
	case IDM_OPEN:
		for( wIx = 0; wIx < gCnt; wIx++ ) {
			// AhX擾
			GetDlgItemText( hWnd, IDC_ADRS, szBuf, 10 );
			htol( szBuf, &dwAdr );
			// AhXԂ̐ݒ擾
			if( IsDlgButtonChecked( hWnd, IDR_IOACC ) == BST_CHECKED )		dwSpc = 1;	// I/O
			else if( IsDlgButtonChecked( hWnd, IDR_MMACC ) == BST_CHECKED )	dwSpc = 0;	// 
			else															break;
			// gpԃ[h̐ݒ擾
			if( IsDlgButtonChecked( hWnd, IDR_8BYTE ) == BST_CHECKED )			dwMode = 1;	// 8byte[h
			else if( IsDlgButtonChecked( hWnd, IDR_512BYTE ) == BST_CHECKED )	dwMode = 0;	// 512byte[h
			else															break;

			if((gInf[wIx].dwBaseAddress == dwAdr) &&(gInf[wIx].dwAddressSpace == dwSpc) && (gInf[wIx].dwAccessMode == dwMode)){
//			if((((hUse != hMct[wIx]) && (hMct[wIx] == ILL_HNDL)) || ( hUse == ILL_HNDL )) 
//				&& (gInf[wIx].dwBaseAddress == dwAdr)){
				dwRet = h1px_DevOpenEx( &hMct[wIx], &gInf[wIx] );
				if( dwRet ) {
					mct_msg( hMct[wIx], 0, 0, dwRet );
					return (1);
				} else {
					hUse = hMct[wIx];
					gUse = gInf[wIx];
				}
				dwRet = mct110_wOptPortW( hUse, 2,  0 );
				if( dwRet ) {
					mct_msg( hUse, 0, 0, dwRet );
					return (1);
				}
				SetTimer( hWnd, IDD_TMR, 110, NULL );
				inf_disp( hWnd, wIx );		// ޲\
				mid_disp( hWnd, 0 );		// ӼޭID\
				spd_disp( hWnd );			// ʐMx\
				EnableWindow((GetDlgItem( hWnd, IDC_ADRS )), FALSE );
				EnableWindow((GetDlgItem( hWnd, IDC_SLCTADRS )), FALSE );
				EnableWindow((GetDlgItem( hWnd, IDR_IOACC )), FALSE );
				EnableWindow((GetDlgItem( hWnd, IDR_MMACC )), FALSE );
				EnableWindow((GetDlgItem( hWnd, IDC_SLCTMODE )), FALSE );
				EnableWindow((GetDlgItem( hWnd, IDR_8BYTE )), FALSE );
				EnableWindow((GetDlgItem( hWnd, IDR_512BYTE )), FALSE );
				EnableMenuItem( hMenu, IDM_OPEN, MF_GRAYED );
				EnableMenuItem( hMenu, IDM_CLOSE, MF_ENABLED );
				ShowWindow(tbWnd, SW_RESTORE);
			} 
		}
		break;
	case IDM_CLOSE:
		EnableWindow((GetDlgItem( hWnd, IDC_ADRS )), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDC_SLCTADRS )), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDR_IOACC )), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDR_MMACC )), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDC_SLCTMODE )), TRUE);
		EnableWindow((GetDlgItem( hWnd, IDR_8BYTE )), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDR_512BYTE )), TRUE );
		EnableMenuItem( hMenu, IDM_OPEN, MF_ENABLED );
		EnableMenuItem( hMenu, IDM_CLOSE, MF_GRAYED );
		SetDlgItemText( hWnd, IDC_DEVINFO, "" );
		KillTimer( hWnd, IDD_TMR );
		close_mct();
		ShowWindow(tbWnd, SW_HIDE);
		break;
	case IDM_STA1: 
		dwRet = mid_disp( hWnd, 0 );	// ӼޭID\
		if( dwRet == 0 ) {
			mct_csta( hUse, 0 );		// ײ1دʐMJn
										
			// ײ݂ɐڑꂽӼޭق̏
			for( dwMid = 0; dwMid < 64; dwMid++ ) { 
				dwRet = h1px_InitMotionModule( hUse, 0, (WORD)dwMid );
				if(( dwRet != 0 ) && ( dwRet != ILLEGAL_PARAM )) {
					mct_msg( hUse, 0, (WORD)dwMid, dwRet );
					break;
				}
			}
		} else {
			mct_msg( hUse, 0, 0, dwRet );
		}
		break;		
	case IDM_STP1:
		dwRet = IsPulseOut( hUse, 0 );	// ٽo͊mF
		if( dwRet == 1 ) {				// ٽo͒
			MessageBox( hWnd, "ײ݂ɐڑꂽӼޭقٽo͒łB", "", MB_OK | MB_ICONWARNING );
			break;
		} else if(dwRet == 2) {			// ̴̑װ
			KillTimer( hWnd, IDD_TMR );
			break;
		}
		nAns = MessageBox( hWnd, "دʐM~,ײ݂ɐڑꂽӼޭق̐䂪łȂȂȂ܂B\n{ɒ~܂H", "", MB_OKCANCEL | MB_ICONWARNING );
		if(nAns == IDOK) {
			for( dwIx = 0; dwIx < MAX_MDL; dwIx++ ) {
				if( hPos[dwIx] != 0 ) {
					if(( gPmdl[dwIx].dev == hUse ) &&
					   ( gPmdl[dwIx].lno == 0 )) {
						CloseWindow( hPos[dwIx] );
						hPos[dwIx] = 0;
					}
				}				
				if( hDio[dwIx] != 0 ) {
					if(( gDmdl[dwIx].dev == hUse ) &&
					   ( gDmdl[dwIx].lno == 0 )) {
						CloseWindow( hDio[dwIx] );
						hDio[dwIx] = 0;
					}
				}	
			}
			SetDlgItemInt( hWnd, ID_EDT_LIN1P, 0, FALSE );
			SetDlgItemInt( hWnd, ID_EDT_LIN1D, 0, FALSE );
			SendDlgItemMessage( hWnd, ID_CMB_LIN1P, CB_RESETCONTENT , 0, 0 );
			SendDlgItemMessage( hWnd, ID_CMB_LIN1D, CB_RESETCONTENT , 0, 0 );
			mct_cstp( hUse, 0 ); 		// ײ1دʐM~
		}
		break;
	case IDD_OUT1:	mct_wout( hUse, 1 ); break;		// ϽްOUT1o
	case IDD_OUT2:	mct_wout( hUse, 2 ); break;		// ϽްOUT1o
	case IDD_OUT3:	mct_wout( hUse, 4 ); break;		// ϽްOUT1o
	case IDD_OUT4:	mct_wout( hUse, 8 ); break;		// ϽްOUT1o
	case ID_CMB_LIN1P:
		if( HIWORD( wParam ) == CBN_SELCHANGE ) {
			index = SendDlgItemMessage( hWnd, ID_CMB_LIN1P, CB_GETCURSEL, 0, 0 );
			SendDlgItemMessage( hWnd, ID_CMB_LIN1P, CB_GETLBTEXT, index, (LPARAM)szBuf );
			htol( szBuf, &dwMid );
			for( dwIx = 0; dwIx < MAX_MDL; dwIx ++ ) {
				if( hPos[dwIx] == 0 ) {
					break;
				} else {
					if(( gPmdl[dwIx].dev == hUse ) &&
					   ( gPmdl[dwIx].lno == 0 )          &&
					   ( gPmdl[dwIx].mid == (WORD)dwMid )) {
						MessageBox( hWnd, "w肵ӰӼޭق͊ɕ\Ă܂B", "", MB_OK );
						return 0;
					}
				}
			}
			if( dwIx == MAX_MDL ) {
				wsprintf( szBuf, "۸тňӰӼޭِ%d܂łłB", MAX_MDL );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;	
			}			
			gPmdl[dwIx].dev = hUse;
			gPmdl[dwIx].lno = 0;
			gPmdl[dwIx].mid  = (WORD)dwMid;
			hPos[dwIx] = CreateDialog( gInst, "POS", hWnd, (DLGPROC)PosProc );
			ShowWindow( hPos[dwIx], SW_SHOW );
			wsprintf( szBuf, "BID=%x:LINE1:M ID=%02xh Motion Module", (hUse >> 16), dwMid );
			SetWindowText( hPos[dwIx], szBuf );
			p_idisp( hPos[dwIx] );
			dwRet = p_init( hPos[dwIx] );	// ӰӼޭُ
			if( dwRet ) {
				mct_msg( hUse, 0, (WORD)dwMid, dwRet );
				break;
			}			
		} 
		break;

	case ID_CMB_LIN1D:
		if( HIWORD( wParam ) == CBN_SELCHANGE ) {
			index = SendDlgItemMessage( hWnd, ID_CMB_LIN1D, CB_GETCURSEL, 0, 0 );
			SendDlgItemMessage( hWnd, ID_CMB_LIN1D, CB_GETLBTEXT, index, (LPARAM)szBuf );
			htol( szBuf, &dwMid );
			for( dwIx = 0; dwIx < MAX_MDL; dwIx++ ) {
				if( hDio[dwIx] == 0 ) {
					break;
				} else {
					if(( gDmdl[dwIx].dev == hUse ) &&
					   ( gDmdl[dwIx].lno == 0 )          &&
					   ( gDmdl[dwIx].mid == (WORD)dwMid )) {
						MessageBox( hWnd, "w肵DIOӼޭق͊ɕ\Ă܂B", "", MB_OK );
						return 0;
					}
				}
			}
			if( dwIx == MAX_MDL ) {
				wsprintf( szBuf, "۸тňDIOӼޭِ%d܂łłB", MAX_MDL );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;	
			}			
			gDmdl[dwIx].dev = hUse;
			gDmdl[dwIx].lno = 0;
			gDmdl[dwIx].mid  = (WORD)dwMid;
			hDio[dwIx] = CreateDialog( gInst, "DIO", hWnd, (DLGPROC)DioProc );
			ShowWindow( hDio[dwIx], SW_SHOW );
			wsprintf( szBuf, "BID=%x:LINE1:M ID=%02xh DIO", (hUse >> 16), dwMid );
			SetWindowText( hDio[dwIx], szBuf ); 
			dwRet = d_init( hDio[dwIx] );	// G9002
			if( dwRet ) {
				mct_msg( hUse, 0, (WORD)dwMid, dwRet );
				break;
			}			
		} 
		break;
	}
	return 0 ;
}

//
// user timer
//
LRESULT userTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	WORD	prt[2];
	P_STS	p;
	DWORD	dwIx;
	DWORD	hdev, dwRet, dwSts;
	WORD	wLno, wMid, wMst, wSts;
	char	szBuf[128];

	switch( wParam ) {
		case IDD_TMR:
			opt_disp( hWnd );
			cyc_disp( hWnd );					
			for( dwIx = 0; dwIx < MAX_MDL; dwIx++ ) {
				if( hDio[dwIx] ) {
					hdev = gDmdl[dwIx].dev;
					wLno = gDmdl[dwIx].lno;
					wMid = gDmdl[dwIx].mid;
					dwRet = mct110_rCenMsts( hdev, wLno, &wSts );
					if( dwRet ) {
						KillTimer( hWnd, IDD_TMR );
						mct_msg( hUse, wLno, wMid, dwRet );
						return (1);
					}
					if( wSts & 0x1000 ) {			// دʐM
						if( wSts & 0x0008 ) {		// دʐMװ
							mct_msg( hdev, wLno, wMid, CYC_COM_ERROR );	
						} else {
							dwRet = d_rprt( hdev, wLno, wMid, &prt[0], &prt[1] );
							if( dwRet ) {
								mct_cstp( hdev, wLno );				// دʐM~
								mct_msg( hdev, wLno, wMid, dwRet );
								return (1);
							}
							d_disp( hDio[dwIx], prt[0], prt[1] );
						}
					} else {						// دʐM~
						wsprintf( szBuf, "BID=%x:LINE%d:M ID=%02xh DIO دʐM~", (hdev >> 16), (wLno+1), wMid );
						SetWindowText( hDio[dwIx], szBuf ); 
					}
				}
				if( hPos[dwIx] ) {
					hdev = gPmdl[dwIx].dev;
					wLno = gPmdl[dwIx].lno;
					wMid = gPmdl[dwIx].mid;
					dwRet = mct110_rCenMsts( hdev, wLno, &wSts );
					if( dwRet ) {
						KillTimer( hWnd, IDD_TMR );
						mct_msg( hUse, wLno, wMid, dwRet );
						return (1);
					}
					if( wSts & 0x1000 ) {			// دʐM
						if( wSts & 0x0008 ) {		// دʐMװ
							mct_msg( hdev, wLno, wMid, CYC_COM_ERROR );	
						} else {
							dwRet = h1px_ReadMainSts( hdev, wLno, wMid, &wMst );
							if( dwRet ) {
								mct_cstp( hdev, wLno );				// دʐM~
								mct_msg( hdev, wLno, wMid, dwRet );
								return (1);
							}
							if( wMst & 4 ) {
								dwRet = h1px_ReadErrorSts( hdev, wLno, wMid, &dwSts );	// װðǏo
								if( dwRet ) {
									mct_cstp( hdev, wLno );			// دʐM~
									mct_msg( hdev, wLno, wMid, dwRet );
									return (1);
								}
								if( dwSts & 0x7ff ) {				// װ~
									end_msg( dwSts );
									ctl_enbl( hPos[dwIx], TRUE );	// ۰َgp
								}
							}
							if( wMst & 8 ) {
								dwRet = h1px_ReadEventSts( hdev, wLno, wMid, &dwSts );	// ĽðǏo
								if( dwRet ) {
									mct_cstp( hdev, wLno );			// دʐM~
									mct_msg( hdev, wLno, wMid, dwRet );
									return (1);
								}
								ctl_enbl( hPos[dwIx], TRUE );		// ۰َgp
							}
							dwRet = p_rsts( gPmdl[dwIx], &p );
							if( dwRet ) {
								mct_cstp( hdev, wLno );				// دʐM~
								mct_msg( hdev, wLno, wMid, dwRet );
								return (1);
							}
 							p_disp( hPos[dwIx], p, gMlt[dwIx] );
						}
					} else {						// دʐM~
						wsprintf( szBuf, "BID=%x:LINE%d:M ID=%02xh Motion Module دʐM~", (hdev >> 16), (wLno+1), wMid );
						SetWindowText( hPos[dwIx], szBuf ); 
					}
				}
			}
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

//
// window procedure
//
LRESULT CALLBACK WndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	int nAns;

	switch( uMessage ) {
		case WM_COMMAND:
			userMenu( hWnd, uMessage, wParam, lParam ); 
			break ;
		case WM_TIMER:
			userTimer( hWnd, uMessage, wParam, lParam ); 
			break;		
		case WM_CLOSE:
			nAns = MessageBox( hWnd, "vOI܂H", "", MB_OKCANCEL );
			if(nAns == IDOK) {
				DestroyWindow( hWnd );
			}
			break;
		case WM_DESTROY:
			KillTimer( hWnd, IDD_TMR );
			close_mct();
			PostQuitMessage( 0 );
			break ;

		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

// ӼޭID\
DWORD  mid_disp( HWND hWnd, WORD wLno ) 
{
	DWORD	dwRet = 0;
	WORD	wMid, 
			p_cnt = 0, 
			d_cnt = 0;
	char	szBuf[128];
	BYTE	byData;
		
	SendDlgItemMessage( hWnd, ID_CMB_LIN1P+wLno, CB_RESETCONTENT , 0, 0 );
	SendDlgItemMessage( hWnd, ID_CMB_LIN1D+wLno, CB_RESETCONTENT , 0, 0 );

	// ђʐMJn
	dwRet = mct_ssys( hUse, wLno );
	if( dwRet )	{
		KillTimer( hWnd, IDD_TMR );
		mct_msg( hUse, wLno, 0, dwRet );
		return (dwRet);
	}
	for( wMid = 0; wMid < 64; wMid++ ) { 
		dwRet = mct110_rLclInfo( hUse, wLno, wMid, &byData );	// ۰޲Ǐo
		if( dwRet )	{
			KillTimer( hWnd, IDD_TMR );
			mct_msg( hUse, wLno, wMid, dwRet );
			return (dwRet);
		}
		if( byData & 0x80 ) {
			if( byData & 0x8 ) {	// Motion
				wsprintf( szBuf, "%02x", wMid );
				SendDlgItemMessage( hWnd, ID_CMB_LIN1P+wLno, CB_ADDSTRING, 0, (LPARAM)szBuf );
				p_cnt++;
			} else {				// DIO
				wsprintf( szBuf, "%02x", wMid );
				SendDlgItemMessage( hWnd, ID_CMB_LIN1D+wLno, CB_ADDSTRING, 0, (LPARAM)szBuf );
				d_cnt++;
			}
		}
	}
	SetDlgItemInt( hWnd, ID_EDT_LIN1P+wLno, p_cnt, FALSE );
	SetDlgItemInt( hWnd, ID_EDT_LIN1D+wLno, d_cnt, FALSE );
	SendDlgItemMessage( hWnd, ID_CMB_LIN1P+wLno, CB_SETCURSEL, 0, 0 );
	SendDlgItemMessage( hWnd, ID_CMB_LIN1D+wLno, CB_SETCURSEL, 0, 0 );
	if((p_cnt==0)&&(d_cnt==0)) {
		return (NO_LOCAL);
	} else {
		return (0);
	}
}

// ߼߰ďԕ\
void  opt_disp( HWND hWnd )
{
	DWORD dwRet = 0;
	WORD  wData;
	
	dwRet = mct_rinp( hUse, &wData );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		mct_msg( hUse, 0, 0, dwRet );	
		return;
	}
	if( wData & 1 )	
		SendDlgItemMessage( hWnd, IDC_IN1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 2 )	
		SendDlgItemMessage( hWnd, IDC_IN2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 4 )	
		SendDlgItemMessage( hWnd, IDC_IN3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 8 )	
		SendDlgItemMessage( hWnd, IDC_IN4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 0x10 )	
		SendDlgItemMessage( hWnd, IDC_IN5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 0x20 )	
		SendDlgItemMessage( hWnd, IDC_IN6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 0x40 )	
		SendDlgItemMessage( hWnd, IDC_IN7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	if( wData & 0x80 )	
		SendDlgItemMessage( hWnd, IDC_IN8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_IN8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	dwRet = mct_rout( hUse, &wData );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		mct_msg( hUse, 0, 0, dwRet );
		return;
	}
	if( wData & 1 )	
		SendDlgItemMessage( hWnd, IDD_OUT1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_OUT1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wData & 2 )	
		SendDlgItemMessage( hWnd, IDD_OUT2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_OUT2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wData & 4 )	
		SendDlgItemMessage( hWnd, IDD_OUT3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_OUT3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wData & 8 )	
		SendDlgItemMessage( hWnd, IDD_OUT4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_OUT4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );

}	

// MCAT̴װү
void mct_msg( DWORD hDev, WORD wLno, WORD wMid, DWORD code )
{
	char	szTmp[1024] = {0};
	char	szBuf[1024] = {0};
	char	szCap[1024] = {0};
	DWORD	dwRet;
	WORD	wSts, wBid, wIx, wJx;

	if( code & NOT_FOUND )				strcat( szBuf, "޲݂Ȃ.\n" );
	if( code & ALREADY_OPENED )			strcat( szBuf, "d.\n" );
	if( code & INSUFFICIENT_MEMORY )	strcat( szBuf, "ؕs.\n" );
	if( code & INVALID_HANDLE )			strcat( szBuf, ".\n" );
	if( code & NOT_READY )				strcat( szBuf, "޲̓o߰Ďgps\.\n" );
	if( code & ILLEGAL_DEVICE )			strcat( szBuf, "ް޺ނǂ߂Ȃ.\n" );
	if( code & ILLEGAL_PARAM )			strcat( szBuf, "͈͊O.\n" );
	if( code & MODULE_OVERCOUNT )		strcat( szBuf, "Ӽޭق̐1ײ33ȏ.\n" );
	if( code & NO_LOCAL )				strcat( szBuf, "۰޲Ȃ.\n" );
	if( code & CYC_COM_ERROR ) {
		mct_cstp( hDev, wLno );		// دʐM~
		SetDlgItemInt( gWnd, ID_EDT_LIN1P+wLno, 0, FALSE );
		SetDlgItemInt( gWnd, ID_EDT_LIN1D+wLno, 0, FALSE );
		SendDlgItemMessage( gWnd, ID_CMB_LIN1P+wLno, CB_RESETCONTENT , 0, 0 );
		SendDlgItemMessage( gWnd, ID_CMB_LIN1D+wLno, CB_RESETCONTENT , 0, 0 );

		wsprintf( szBuf, "دʐMװ.\n" );
		for( wJx = 0; wJx < 4; wJx++ ) {
			dwRet = mct110_rLclCycErr( hDev, wLno, wJx, &wSts );
			dwRet = mct110_wLclCycErr( hDev, wLno, wJx,  wSts );
			for( wIx = 0; wIx < 16; wIx++ ) {
				if(wSts & (0x0001<<wIx)) {
					wsprintf( szTmp, "װӼޭID:%02x\n",(wJx*16+wIx) );
					strcat( szBuf, szTmp );
				}
			}
		}
		wBid = (WORD)( hDev >> 16 );
		wsprintf( szCap, "B_ID:%x LINE%d M_ID:%02x", wBid, (wLno+1), wMid );
	}
	if( code & CYC_COM_STOP )			strcat( szBuf, "دʐM~.\n" );
	if( code & DATA_COM_ERROR )	{
		dwRet = mct110_rCenIsts( hDev, wLno, &wSts );
		wsprintf( szBuf, "ްʐMװ.\nװӼޭID:%02x\n", (wSts & 0x003f));
		wBid = (WORD)( hDev >> 16 );
		wsprintf( szCap, "B_ID:%x LINE%d M_ID:%02x", wBid, (wLno+1), wMid );	
	}
	if( code & COM_OTHER_ERROR ) 		strcat( szBuf, "̑̒ʐMװ.\n" );
	if( code & ILL_ACCESS_COM )	{
		strcat( szBuf, "ʐM̕sȱ.\n" );
		dwRet = mct110_rCenIsts( hDev, wLno, &wSts );
		if(( wSts & 0x0f00 ) == 0x0100) strcat( szBuf, "PMDݒƈႤI/OްM\n" ); 
		if(( wSts & 0x0f00 ) == 0x0200) strcat( szBuf, "DIOӼޭقްʐMڰтM\n" ); 
		if(( wSts & 0x0f00 ) == 0x0300) strcat( szBuf, "ް޲Mޯ̧eʈȏڰюM\n" ); 
		if(( wSts & 0xf000 ) == 0x1000) strcat( szBuf, "gp޲Ȃł̻دʐMw\n" ); 
		if(( wSts & 0xf000 ) == 0x2000) strcat( szBuf, "MްȂłްMw\n" ); 
		if(( wSts & 0xf000 ) == 0x3000) strcat( szBuf, "/ްʐM̑MpFIFOǏo\n܂ͼ/ްʐMw\n" ); 
		if(( wSts & 0xf000 ) == 0x4000) strcat( szBuf, "gp޲ւްM\n" ); 
		wBid = (WORD)( hDev >> 16 );
		wsprintf( szCap, "B_ID:%x LINE%d M_ID:%02x", wBid, (wLno+1), wMid );
	}
	if( code & SEND_DATA_NONUSE )		strcat( szBuf, "gp޲ްM.\n" );
	if( code & OTHER_ERROR )			strcat( szBuf, "̴̑װ.\n" );

	MessageBox( NULL, szBuf, szCap, MB_OK );
}

// G9003̴װү
void end_msg( DWORD code )
{
	char szBuf[1024];

	strcpy( szBuf, "" );
	if( code & 0x00000001 )		strcat( szBuf, "CMP1ɂ~.\n" );
	if( code & 0x00000002 )		strcat( szBuf, "CMP2ɂ~.\n" );
	if( code & 0x00000004 )		strcat( szBuf, "CMP3ɂ~.\n" );
	if( code & 0x00000008 )		strcat( szBuf, "+ELSɂ~.\n" );
	if( code & 0x00000010 )		strcat( szBuf, "-ELSɂ~.\n" );
	if( code & 0x00000020 )		strcat( szBuf, "SVALMɂ~.\n" );
	if( code & 0x00000040 )		strcat( szBuf, "CSTPɂ~.\n" );
	if( code & 0x00000080 )		strcat( szBuf, "EMGɂ~.\n" );
	if( code & 0x00000100 )		strcat( szBuf, "DLSɂ~.\n" );
	if( code & 0x00000200 )		strcat( szBuf, "ٽޯ̧ް۰.\n" );
	if( code & 0x00000400 )		strcat( szBuf, "ʐMװɂ~.\n" );
	if( code & 0x00001000 )		strcat( szBuf, "ʒu̵ײގs.\n" );
	if( code & 0x00006000 )		strcat( szBuf, "װ.\n" );
	MessageBox( NULL, szBuf, "Error Message", MB_OK );	
}





