Option Strict Off
Option Explicit On
Module hmct110
	'=============================================================================
	'   Driver for Windows
	'   I/F DLL Function
    '       file name:hmct110.vb
    '       date     :2008/10/03
	'       version  :VK쐬
	'   Copyright(C) 2008
	'   Hivertec Inc. All Rights Reserved.
	'=============================================================================
	
	' ----------------------------------------------------------------------------
	' 萔`
	' ----------------------------------------------------------------------------
    Public Const NOT_FOUND As Integer = &H1S            ' ޲݂Ȃ
    Public Const ALREADY_OPENED As Integer = &H2S       ' d
    Public Const INSUFFICIENT_MEMORY As Integer = &H4S  ' ؕs
    Public Const INVALID_HANDLE As Integer = &H8S       ' 
    Public Const NOT_READY As Integer = &H10S           ' ޲̓o߰Ďgps\
    Public Const ILLEGAL_DEVICE As Integer = &H20S      ' ް޺ނǂ߂Ȃ
    Public Const ILLEGAL_PARAM As Integer = &H100S      ' ͈͊O
    Public Const CYC_COM_ERROR As Integer = &H10000     ' دʐMװ
    Public Const CYC_COM_STOP As Integer = &H20000      ' دʐM~
    Public Const DATA_COM_ERROR As Integer = &H40000    ' ްʐMװ
    Public Const COM_OTHER_ERROR As Integer = &H80000   ' ̑̒ʐMװ
    Public Const OTHER_ERROR As Integer = &H80000000    ' ̴̑װ
	
	' ----------------------------------------------------------------------------
	' \
	' ----------------------------------------------------------------------------
	' foCX
	Public Structure HMCT110INFO
        Dim dwBusNumber As Integer      ' oXԍ
        Dim dwBaseAddress As Integer    ' x[XAhX
        Dim dwIrqNo As Integer          ' IRQ ԍ
        Dim dwNumber As Integer         ' Ǘԍ
        Dim dwAddressSpace As Integer   ' AhX(1:I/O, 0:MEM)
        Dim dwAccessMode As Integer     ' AhXԃ[h(1:8byte, 0:512byte)
	End Structure
	
	
	'------------------------------------------------------------------------------
	' DLL֐vg^Cv
    '------------------------------------------------------------------------------
    '1  MCAT110̎擾
    Declare Function mct110_GetMstBrdCount Lib "hmct110.dll" (ByRef count As Integer) As Integer
    '2  MCAT110foCX̎擾
    Declare Function mct110_GetMstBrdInfo Lib "hmct110.dll" (ByRef count As Integer, ByRef hInfo As HMCT110INFO) As Integer
    '3  MCAT110̃I[v
    Declare Function mct110_OpenMstBrd Lib "hmct110.dll" (ByRef hDev As Integer, ByRef hInfo As HMCT110INFO) As Integer
    '4  MCAT110̃N[Y
    Declare Function mct110_CloseMstBrd Lib "hmct110.dll" (ByVal hDev As Integer) As Integer
    '5  Z^[foCXXe[^XǏo
    Declare Function mct110_rCenMsts Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByRef wSts As Short) As Integer
    '6  Z^[foCXR}h
    Declare Function mct110_wCenCmd Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wCmd As Short) As Integer
    '7  Z^[foCX݃Xe[^XǏo
    Declare Function mct110_rCenIsts Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByRef wSts As Short) As Integer
    '8  Z^[foCXo̓obt@Ǐo
    Declare Function mct110_rCenBuf Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByRef wInBuf As Short) As Integer
    '   Z^[foCXo̓obt@
    Declare Function mct110_wCenBuf Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wInBuf As Short) As Integer
    '9  Z^[foCXMpehenǏo
    Declare Function mct110_rCenRFiFo Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByRef wReceive As Short) As Integer
    '   Z^[foCXMpehen
    Declare Function mct110_wCenSFiFo Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wSend As Short) As Integer
    '10 TCNbNʐMG[tOǏo
    Declare Function mct110_rLclCycErr Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMidPrm As Short, ByRef wFlag As Short) As Integer
    '   TCNbNʐMG[tOZbg
    Declare Function mct110_wLclCycErr Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMidPrm As Short, ByVal wFlag As Short) As Integer
    '11 [JfoCX(DIOCӰ)Ǐo
    Declare Function mct110_rLclInfo Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByRef byData As Byte) As Integer
    '   [JfoCX(DIOCӰ)񏑍
    Declare Function mct110_wLclInfo Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal byData As Byte) As Integer
    '12 [JfoCX(DIOCӰ)͕ωݐݒԓǏo
    Declare Function mct110_rLclSetInt Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMidPrm As Short, ByRef wData As Short) As Integer
    '   [JfoCX(DIOCӰ)͕ωݐݒ菑
    Declare Function mct110_wLclSetInt Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMidPrm As Short, ByVal wData As Short) As Integer
    '13 [JfoCX(DIOCӰ)͕ω݃tOǏo
    Declare Function mct110_rLclInt Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMidPrm As Short, ByRef wFlag As Short) As Integer
    '   [JfoCX(DIOCӰ)͕ω݃tOZbg
    Declare Function mct110_wLclInt Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMidPrm As Short, ByVal wFlag As Short) As Integer
    '14 DIO޲w|[gPoCgǏo
    Declare Function mct110_rIoPortB Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wPrtNo As Short, ByRef byData As Byte) As Integer
    '   DIO޲w|[gPoCg
    Declare Function mct110_wIoPortB Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wPrtNo As Short, ByVal byData As Byte) As Integer
    '   DIO޲w|[gQoCgǏo
    Declare Function mct110_rIoPortW Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wPrtNo As Short, ByRef wData As Short) As Integer
    '   DIO޲w|[gQoCg
    Declare Function mct110_wIoPortW Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wPrtNo As Short, ByVal wData As Short) As Integer
    '15 Ӱ޲o̓|[gPoCgǏo
    Declare Function mct110_rPclPort Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByRef byData As Byte) As Integer
    '   Ӱ޲o̓|[gPoCg
    Declare Function mct110_wPclPort Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal byData As Byte) As Integer
    '16 Ӱ޲CXe[^XǏo
    Declare Function mct110_rPclMsts Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByRef wSts As Short) As Integer
    '17 Ӱ޲R}h
    Declare Function mct110_wPclCmd Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wCmd As Short) As Integer
    '18 Ӱ޲WX^Ǐo
    Declare Function mct110_rPclReg Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wCmd As Short, ByRef dwReg As Integer) As Integer
    '   Ӱ޲WX^
    Declare Function mct110_wPclReg Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wLine As Short, ByVal wMid As Short, ByVal wCmd As Short, ByVal dwReg As Integer) As Integer
    '19 IvV|[gPoCgǏo
    Declare Function mct110_rOptPortB Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wAdrs As Short, ByRef byData As Byte) As Integer
    '   IvV|[gQoCgǏo
    Declare Function mct110_rOptPortW Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wAdrs As Short, ByRef wData As Short) As Integer
    '   IvV|[gPoCg
    Declare Function mct110_wOptPortB Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wAdrs As Short, ByVal byData As Byte) As Integer
    '   IvV|[gQoCg
    Declare Function mct110_wOptPortW Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wAdrs As Short, ByVal wData As Short) As Integer
    '20 Z^[foCXw|[gQoCgǏo
    Declare Function mct110_rCenPortW Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wAdrs As Short, ByRef wData As Short) As Integer
    '   Z^[foCXw|[gQoCg
    Declare Function mct110_wCenPortW Lib "hmct110.dll" (ByVal hDev As Integer, ByVal wAdrs As Short, ByVal wData As Short) As Integer
End Module