//
// Progmain.c
//
#include <windows.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "s1p10000.h"

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );

void	InitDialog( HWND );			// initialize dialog
void	close_board( HWND );		// {[h̏I

//
// register main window calss
//
BOOL InitApplication( HINSTANCE hInstance )
{
	WNDCLASSEX  wc;

	if( hInstance )	{
		// EBhENX`
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			// EBhE̎(TCYύXĕ`)
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					// EChE֐̃AhX
		wc.cbClsExtra	 =	0;									// ̑̃NX
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						// ̑̃EBhE
		wc.hInstance	 =	hInstance;							// ̃CX^X̃nh
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	// WACR̃nh
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		// }EXJ[\̃nh
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		// EBhE̔wiF({^̕\ʂ̉e)
		wc.lpszMenuName	 =	NULL;								// Cj[̖O
		wc.lpszClassName =	"MENU";								// EBhENX̖O
		wc.cbSize		 =	sizeof(WNDCLASSEX);					// WNDCLASSEX\̂̃TCYݒ
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		// X[ACR		
	}
	return( RegisterClassEx(&wc) );								// WNDCLASS̓o^
}


//
// careate main window
//
HWND InitInstance( HINSTANCE gInstance, int nCmdShow )
{
	HWND hWnd;

	hWnd = CreateDialog( gInstance, "0MENU", 0, NULL );

	return hWnd;
}


//
// WinMain
//
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,	LPSTR lpCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;

	// register main window class
	if( !InitApplication( hInstance ) )				return FALSE;

	// create main window
	if(!( hWnd = InitInstance(hInstance, nCmdShow )))	return FALSE;

	if( hWnd != NULL ) {
		gMenu  = hWnd;
		gInst = hInstance;
		InitDialog( hWnd );
		ShowWindow( hWnd, nCmdShow );
		UpdateWindow( hWnd );
	}
	
	// dispatch messages
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(!IsDialogMessage( hWnd, &msg )) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	return msg.wParam;
}

//
// user menu
//
LRESULT userMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	char szBuf[128];
	
	switch( LOWORD( wParam )) {
	case IDC_RD_DEV:		// foCXI[v^N[Y
		hDlg = CreateDialog( gInst, "1DEV", hWnd, (DLGPROC)devProc );
		ShowWindow( hDlg, SW_SHOW );
		SetWindowText( hDlg, "޲/۰޻" );
		ShowWindow( gMenu, SW_HIDE );
		break;
	case IDC_RD_ORG:		// _A
		if( IniDev( hWnd ) == 0 ) {
			hDlg = CreateDialog( gInst, "2ORG", hWnd, (DLGPROC)orgProc );
			ShowWindow( hDlg, SW_SHOW );
			wsprintf( szBuf, "B_ID:%d LINE%d M_ID:%02x HM-P100C _A", BRD_ID, (LINE_NO+1), MDL_NO1 );
			SetWindowText( hDlg, szBuf );
			ShowWindow( gMenu, SW_HIDE );
		}
		break;
	case IDC_RD_CNT:		// A蓮
		if( IniDev( hWnd ) == 0 ) {
			hDlg = CreateDialog( gInst, "3CNT", hWnd, (DLGPROC)cntProc );
			ShowWindow( hDlg, SW_SHOW );
			wsprintf( szBuf, "B_ID:%d LINE%d M_ID:%02x HM-P100C A", BRD_ID, (LINE_NO+1), MDL_NO1 );
			SetWindowText( hDlg, szBuf );
			ShowWindow( gMenu, SW_HIDE );
		}
		break;
	case IDC_RD_POS:		// ʒuߓ
		if( IniDev( hWnd ) == 0 ) {
			hDlg = CreateDialog( gInst, "4POS", hWnd, (DLGPROC)posProc );
			ShowWindow( hDlg, SW_SHOW );
			wsprintf( szBuf, "B_ID:%d LINE%d M_ID:%02x HM-P100C ʒu߻", BRD_ID, (LINE_NO+1), MDL_NO1 );
			SetWindowText( hDlg, szBuf );
			ShowWindow( gMenu, SW_HIDE );
		}
		break;
	case IDC_RD_MLT:		// 
		if( IniDev( hWnd ) == 0 ) {
			hDlg = CreateDialog( gInst, "5MLT", hWnd, (DLGPROC)mltProc );
			ShowWindow( hDlg, SW_SHOW );
			wsprintf( szBuf, "B_ID:%d LINE%d M_ID:%02x, M_ID:%02x HM-P100C ", BRD_ID, (LINE_NO+1), MDL_NO1, MDL_NO2 );
			SetWindowText( hDlg, szBuf );
			ShowWindow( gMenu, SW_HIDE );
		}
		break;
	}
	return 0;
}

//
// window procedure
//
LRESULT CALLBACK WndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( uMessage ) {
		case WM_COMMAND:
			userMenu( hWnd, uMessage, wParam, lParam ); 
			break;
		case WM_CLOSE:
		case WM_DESTROY:
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0;
}

//
// load main dialog
//
void InitDialog(HWND hWnd)
{
	hDev = 0xffffffff;							// foCXnh
	
	// rbg}bṽ[h
	hWht = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_WHT) );
	hGrn = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_GRN) );
	hRed = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_RED) );

	CheckDlgButton( hWnd, IDC_RD_DEV, BST_CHECKED );
}


// I
void close_board( HWND hWnd )
{
	DWORD i;

	for( i = 0; i < MAX_BRD; i++ ) {
		if( hMct[i] != 0xffffffff ) {
			hDev = hMct[i];
			h1px_DevClose(hDev);
			hMct[i] = 0xffffffff;
		}
	}
}

