//
// s1_dev.c
//
#include <windows.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "s1p10000.h"

LRESULT devMenu ( HWND, UINT, WPARAM, LPARAM );

BOOL CALLBACK devProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			SetDlgItemText(hWnd, IDD_HNDL, "");
			SetDlgItemText(hWnd, IDD_DEV, "");
			break ;

		case WM_COMMAND:
			devMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		// I
		case WM_CLOSE:
			EndDev( hWnd );								// foCXI
			DestroyWindow( hWnd );						// _CAO{bNX
			break;

		// I
		case WM_DESTROY:
			hDlg = NULL;
			ShowWindow( gMenu, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT devMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{		
	DWORD		dwRet = 0;
	DWORD		dwCnt = 0;
	WORD		wIx;
	char		szBuf[255];
	char		szSpc[128];
	char		szMod[128];
	HMCT110INFO	inf;			// MCAT޲
	HWND		hwCmb;
	int			nIndex;
	
	switch( wParam ) {
		// foCX擾
		case IDD_GINF:
			// {[h & foCX擾
			dwRet = h1px_GetDevInfo(&g_cnt, &g_inf[0]);
			if(dwRet) {
				wsprintf( szBuf, "foCX񂪎擾ł܂\n߂lF%08xh", dwRet );
				MessageBox( hWnd, szBuf, "", MB_OK );
				return 1;
			}

			// R{{bNX̓eZbg
			hwCmb = GetDlgItem(hWnd, IDD_ADRS);
			SendMessage(hwCmb, CB_RESETCONTENT, 0, 0);

			// R{{bNXɃeLXgACeǉ
			for(wIx = 0; wIx < g_cnt; wIx++) {
				if( g_inf[wIx].dwAddressSpace )	wsprintf( szBuf, "%s%x", "I/O:", g_inf[wIx].dwBaseAddress );	// IO
				else							wsprintf( szBuf, "%s%x", "MEM:", g_inf[wIx].dwBaseAddress );	// MEM
//				SendDlgItemMessage( hWnd, IDD_ADRS, CB_ADDSTRING, 0, (LPARAM)szBuf );
				SendMessage(hwCmb, CB_ADDSTRING, 0, (LPARAM)szBuf);
			}
			SendMessage(hwCmb, CB_SETCURSEL, 0, 0);

			// ʕ\
			EnableWindow(GetDlgItem(hWnd, IDD_OPEN), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDD_ADRS), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDD_GINF), FALSE);
			break;

		// foCXI[v
		case IDD_OPEN:
			// {[hw
			nIndex = SendDlgItemMessage( hWnd, IDD_ADRS, CB_GETCURSEL, 0, 0 );
			inf = g_inf[nIndex];
			
			// foCXI[v
			dwRet = h1px_DevOpenEx(&hDev, &inf);
			if(dwRet) {
				wsprintf( szBuf, "foCXI[vł܂.\n߂lF%08xh", dwRet );
				MessageBox(hWnd, szBuf, "", MB_OK);
				return dwRet;
			}

			// foCXnh\
			wsprintf(szBuf, "%s%08xh", "foCXnhF", hDev);
			SetDlgItemText(hWnd, IDD_HNDL, szBuf);

			// foCX\
			if( inf.dwAddressSpace )	wsprintf( szSpc, "I/O" );		// IO
			else						wsprintf( szSpc, "MEM" );		// MEM
			if( inf.dwAccessMode )		wsprintf( szMod, "8byte" );		// 8byte
			else						wsprintf( szMod, "512byte" );	// 512byte
			wsprintf(szBuf, "%s\n%s%ld\n%s%lx%s\n%s%ld\n%s%ld\n%s%s\n%s%s",	
					"**** foCX ****",
					"oXԍF          ", inf.dwBusNumber,
					"x[XAhXF    ", inf.dwBaseAddress, "h",
					"IRQԍF           ", inf.dwIrqNo,
					"ǗԍF          ", inf.dwNumber,
					"AhXԁF      ", szSpc,
					"gpԃ[hF    ", szMod );
			SetDlgItemText(hWnd, IDD_DEV, szBuf);
			
			// ʕ\
			EnableWindow(GetDlgItem(hWnd, IDD_OPEN), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDD_GINF), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDD_ADRS), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDD_CLOS), TRUE);					
			break;

		// foCXN[Y
		case IDD_CLOS:
			// foCXN[Y
			h1px_DevClose(hDev);

			// foCXnh\
			SetDlgItemText(hWnd, IDD_HNDL, "");

			// foCX\
			SetDlgItemText(hWnd, IDD_DEV, "");

			// ʕ\
			EnableWindow(GetDlgItem(hWnd, IDD_OPEN), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDD_GINF), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDD_ADRS), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDD_CLOS), FALSE);	
			break;
	}
	return 0;
}
