//
// s2_org.c
//
#include <windows.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "s1p10000.h"

LRESULT orgMenu ( HWND, UINT, WPARAM, LPARAM );
LRESULT orgTimer( HWND, UINT, WPARAM, LPARAM );
void	orgSts( HWND );
void	orgLoad( HWND );		// _Ã_CAO{bNX̏
void	orgMsg( HWND, DWORD );	// G9003̃G[܂̓Cxg\

BOOL CALLBACK orgProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	DWORD dwRet = 0;
	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			orgLoad( hWnd );
			SetTimer( hWnd, IDD_TMR, 110, NULL );
			break ;
		case WM_COMMAND:
			orgMenu( hWnd, uMessage, wParam, lParam ); 
			break;
		case WM_TIMER:
			orgTimer( hWnd, uMessage, wParam, lParam ); 
			break;		
		// I
		case WM_CLOSE:
			KillTimer( hWnd, IDD_TMR );					// ^C}[~
			EndDev( hWnd );								// foCXI
			DestroyWindow( hWnd );						// _CAO{bNX
			break;
		// I
		case WM_DESTROY:
			hDlg = NULL;
			ShowWindow( gMenu, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT orgMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{		
	DWORD	dwRet,
			dwRfh;
	BYTE	byData;
	BOOL	b;
	
	switch( wParam ) {
	case IDD_ORG1:		// ZT_A(OLSo㔲oē˓)
		// ELSo~
		if( IsDlgButtonChecked( hWnd, ID_CHK_ELS1 ) == BST_CHECKED ) {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 1, 0 );
		} else {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 0, 0 );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
															break;
		}

		// _A[hݒ
		dwRet = h1px_SetOrgMode( hDev, 0, MDL_NO1, 1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}
		
		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// |_A샂[hݒ
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x18 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// X^[g
		dwRet = h1px_AccStart( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}
		
		SetDlgItemText( hWnd, IDD_STATUS, "" );			// Xe[^X\NA

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_ORG1 ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_ORG2 ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_ORG3 ), FALSE );
		break;

	case IDD_ORG2:		// ZT+GR[__A(OLS ono)
		// ELSo~
		if( IsDlgButtonChecked( hWnd, ID_CHK_ELS1 ) == BST_CHECKED ) {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 1, 0 );
		} else {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 0, 0 );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
															break;
		}

		// _A[hݒ
		dwRet = h1px_SetOrgMode( hDev, 0, MDL_NO1, 2 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}
		
		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// |_A샂[hݒ
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x18 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// X^[g
		dwRet = h1px_AccStart( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		SetDlgItemText( hWnd, IDD_STATUS, "" );			// Xe[^X\NA

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_ORG1 ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_ORG2 ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_ORG3 ), FALSE );
															break;
	case IDD_ORG3:		// ZT_A(ELS ono)
		// ELSo~
		if( IsDlgButtonChecked( hWnd, ID_CHK_ELS1 ) == BST_CHECKED ) {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 1, 1 );
		} else {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 0, 1 );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
															break;
		}

		// _A[hݒ
		dwRet = h1px_SetOrgMode( hDev, 0, MDL_NO1, 6 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
															break;
		}
		
		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );

		// |_A샂[hݒ
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x18 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
															break;
		}

		// X^[g
		dwRet = h1px_AccStart( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
															break;
		}

		SetDlgItemText( hWnd, IDD_STATUS, "" );			// Xe[^X\NA

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_ORG1 ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_ORG2 ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_ORG3 ), FALSE );
															break;
	case IDD_STOP:		// ~
		dwRet = h1px_DecStop( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case IDD_SON1:		// SVONo
		dwRet = h1px_ReadOutp( hDev, 0, MDL_NO1, &byData );	// o߰ēǏo
		if( byData & 0x0001 ) {										// SVON ONȂ	
			dwRet = h1px_SvOff( hDev, 0, MDL_NO1 );			// SVON OFF
		} else {													// SVON OFFȂ					
			dwRet = h1px_SvOn( hDev, 0, MDL_NO1 );				// SVON ON
		}			
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case ID_CHK_ELS1:	// ELS͋ɐI
		if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 1, 0 );
			SetDlgItemText( hWnd, wParam, "A" );
		} else {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 0, 0 );
			SetDlgItemText( hWnd, wParam, "B" );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case ID_CHK_ALM1:	// SVALM͋ɐI
		if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
			dwRet = h1px_SetSvAlm( hDev, 0, MDL_NO1, 1, 0 );
			SetDlgItemText( hWnd, wParam, "A" );
		} else {
			dwRet = h1px_SetSvAlm( hDev, 0, MDL_NO1, 0, 0 );
			SetDlgItemText( hWnd, wParam, "B" );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;
	case ID_CHK_OLS:	// OLS͋ɐI
		if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
			dwRet = h1px_SetOls( hDev, 0, MDL_NO1, 1 );
			SetDlgItemText( hWnd, wParam, "A" );
		} else {
			dwRet = h1px_SetOls( hDev, 0, MDL_NO1, 0 );
			SetDlgItemText( hWnd, wParam, "B" );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case ID_CHK_EZ:		// ZʹދɐI
		if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
			dwRet = h1px_SetEz( hDev, 0, MDL_NO1, 0, 1 );
			SetDlgItemText( hWnd, wParam, "A" );
		} else {
			dwRet = h1px_SetEz( hDev, 0, MDL_NO1, 0, 0 );
			SetDlgItemText( hWnd, wParam, "B" );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	}
	return 0;
}


//
// user timer
//
LRESULT orgTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( wParam ) {
		case IDD_TMR:
			orgSts( hWnd );
			break;
	}
	return 0 ;
}

//
//	Xe[^XǍ
//
void orgSts( HWND hWnd )
{
	DWORD	dwRet = 0,
			dwRst,
			dwEst,
			dwIst,
			dwSpd;
	long	lCtr;
	WORD	wMst;
	BYTE	byData;

	// ӰҲݽðǏo
	dwRet = h1px_ReadMainSts( hDev, 0, MDL_NO1, &wMst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	if( wMst & 4 ) {							// G9003װ
		dwRet = h1px_ReadErrorSts( hDev, 0, MDL_NO1, &dwEst );	// װðǏo
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );			// ^C}[~
			MntErrMsg( hWnd, dwRet );			// Motionnet Error Message
			return;
		}
		orgMsg( hWnd, dwEst );					// G[\
		if( dwEst & 0x7ff ) {					// G[~
			EnableWindow( GetDlgItem( hWnd, IDD_ORG1 ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_ORG2 ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_ORG3 ), TRUE );
		}
	}
	if( wMst & 8 ) {							// G9003Ĕ
		dwRet = h1px_ReadEventSts( hDev, 0, MDL_NO1, &dwIst );	// ĽðǏo
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );			// ^C}[~
			MntErrMsg( hWnd, dwRet );			// Motionnet Error Message
			return;
		}
		if( dwIst & 0x0001 ) {					// ~
			while( wMst & 8 ) {
				dwRet = h1px_ReadMainSts( hDev, 0, MDL_NO1, &wMst );
				if( dwRet ) {
					KillTimer( hWnd, IDD_TMR );		// ^C}[~
					MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
					return;
				}
				Sleep(0);
			}
			orgMsg( hWnd, 0 );
			EnableWindow( GetDlgItem( hWnd, IDD_ORG1 ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_ORG2 ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_ORG3 ), TRUE );
		}
	}

	dwRet = h1px_ReadExSts( hDev, 0, MDL_NO1, &dwRst );		// gðǏo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	if( dwRst & 0x0020 )	
		SendDlgItemMessage( hWnd, IDC_ALM1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_ALM1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x0040 )	
		SendDlgItemMessage( hWnd, IDC_PEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_PEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x0080 )	
		SendDlgItemMessage( hWnd, IDC_MEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_MEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x0100 )	
		SendDlgItemMessage( hWnd, IDC_OLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_OLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x10000 )	
		SendDlgItemMessage( hWnd, IDC_EZ, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_EZ, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	
	dwRet = h1px_ReadOutp( hDev, 0, MDL_NO1, &byData );		// o߰ēǏo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	if( byData & 0x0001 )	
		SendDlgItemMessage( hWnd, IDC_SON1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_SON1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	
	dwRet = h1px_ReadCtr( hDev, 0, MDL_NO1, 1, &lCtr );		// CTR1Ǐo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	SetDlgItemInt( hWnd, IDD_CTR1, lCtr, TRUE );

	dwRet = h1px_ReadSpd( hDev, 0, MDL_NO1, &dwSpd );			// wߑxǏo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	SetDlgItemInt( hWnd, IDD_SPD1, dwSpd, FALSE );
}

//	_Ã_CAO{bNX̏
void orgLoad( HWND hWnd )	
{	
	// {^ݒ	
	CheckDlgButton( hWnd, ID_CHK_ELS1, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_CHK_ALM1, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_CHK_OLS, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_CHK_EZ, BST_UNCHECKED );

	// 쑬xGfB^ݒ
	SetDlgItemInt( hWnd, IDD_RFH1, 4000, FALSE );
	SendDlgItemMessage( hWnd, IDD_RFH1, EM_SETLIMITTEXT, 5, 0 );
}

// G9003 G[Iv\
void orgMsg( HWND hWnd, DWORD code )
{
	char buf[1024];
	strcpy( buf, "" );
	if( code == 0 )				strcat( buf, "I." );
	if( code & 0x00000001 )		strcat( buf, "CMP1ɂ~.\n" );
	if( code & 0x00000002 )		strcat( buf, "CMP2ɂ~.\n" );
	if( code & 0x00000004 )		strcat( buf, "CMP3ɂ~.\n" );
	if( code & 0x00000008 )		strcat( buf, "+ELSɂ~.\n" );
	if( code & 0x00000010 )		strcat( buf, "-ELSɂ~.\n" );
	if( code & 0x00000020 )		strcat( buf, "SVALMɂ~.\n" );
	if( code & 0x00000040 )		strcat( buf, "CSTPɂ~.\n" );
	if( code & 0x00000100 )		strcat( buf, "DLSɂ~.\n" );
	if( code & 0x00000200 )		strcat( buf, "ٽޯ̧ް۰.\n" );
	if( code & 0x00000400 )		strcat( buf, "ʐMװɂ~.\n" );
	if( code & 0x00001000 )		strcat( buf, "ʒu̵ײގs.\n" );
	if( code & 0x00006000 )		strcat( buf, "װ.\n" );
	SetDlgItemText( hWnd, IDD_STATUS, buf );
}

