//
// s3_cnt.c
//
#include <windows.h>
#include "resource.h"
#include "h1pxl1a.h"
#include "s1p10000.h"

LRESULT cntMenu ( HWND, UINT, WPARAM, LPARAM );
LRESULT cntTimer( HWND, UINT, WPARAM, LPARAM );
void	cntSts( HWND );
void	cntLoad( HWND );		// Ã_CAO{bNX̏
void	cntMsg( HWND, DWORD );	// G9003̃G[܂̓Cxg\

BOOL CALLBACK cntProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			cntLoad( hWnd );
			SetTimer( hWnd, IDD_TMR, 110, NULL );
			break ;

		case WM_COMMAND:
			cntMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		case WM_TIMER:
			cntTimer( hWnd, uMessage, wParam, lParam ); 
			break;		

		// I
		case WM_CLOSE:
			KillTimer( hWnd, IDD_TMR );		// ^C}[~
			EndDev( hWnd );					// foCXI
			DestroyWindow( hWnd );			// _CAO{bNX
			break;

		// I
		case WM_DESTROY:
			hDlg = NULL;
			ShowWindow( gMenu, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT cntMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{		
	BOOL	b;
	BYTE	byData;
	DWORD	dwRet,
			dwRfh;	

	switch( wParam ) {
	case IDD_PACC:	// +A
		// 샂[hݒ(+A)
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x00 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// X^[g
		dwRet = h1px_AccStart( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_PACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_PFHC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MFHC ), FALSE );
		break;
	case IDD_MACC:	// -A
		// 샂[hݒ(-A)
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x08 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// X^[g
		dwRet = h1px_AccStart( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_PACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_PFHC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MFHC ), FALSE );
															break;
	case IDD_PFHC:	// +葬A
		// 샂[hݒ(+A)
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x00 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// FH葬X^[g
		dwRet = h1px_CnstStartFH( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_PACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_PFHC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MFHC ), FALSE );
															break;
	case IDD_MFHC:	// -葬A
		// 샂[hݒ(-A)
		dwRet = h1px_WritOpeMode( hDev, 0, MDL_NO1, 0x08 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// 쑬xݒ
		dwRfh = GetDlgItemInt( hWnd, IDD_RFH1, &b, FALSE );
		dwRet = h1px_WritFHSpd( hDev, 0, MDL_NO1, dwRfh );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// FH葬X^[g
		dwRet = h1px_CnstStartFH( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
															break;
		}

		// ݎgps
		EnableWindow( GetDlgItem( hWnd, IDD_PACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MACC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_PFHC ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_MFHC ), FALSE );
															break;
	case IDD_DSTP:		// ~
		dwRet = h1px_DecStop( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case IDD_QSTP:		// ~
		dwRet = h1px_QuickStop( hDev, 0, MDL_NO1 );
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case IDD_SON1:		// SVONo
		dwRet = h1px_ReadOutp( hDev, 0, MDL_NO1, &byData );	// o߰ēǏo
		if( byData & 0x0001 ) {										// SVON ONȂ	
			dwRet = h1px_SvOff( hDev, 0, MDL_NO1 );			// SVON OFF
		} else {													// SVON OFFȂ					
			dwRet = h1px_SvOn( hDev, 0, MDL_NO1 );				// SVON ON
		}			
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case ID_CHK_ELS1:	// ELS͋ɐI
		if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 1, 0 );
			SetDlgItemText( hWnd, wParam, "A" );
		} else {
			dwRet = h1px_SetEls( hDev, 0, MDL_NO1, 0, 0 );
			SetDlgItemText( hWnd, wParam, "B" );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;	
	case ID_CHK_ALM1:	// SVALM͋ɐI
		if( IsDlgButtonChecked( hWnd, wParam ) == BST_CHECKED ) {
			dwRet = h1px_SetSvAlm( hDev, 0, MDL_NO1, 1, 0 );
			SetDlgItemText( hWnd, wParam, "A" );
		} else {
			dwRet = h1px_SetSvAlm( hDev, 0, MDL_NO1, 0, 0 );
			SetDlgItemText( hWnd, wParam, "B" );
		}
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
															break;
	case IDD_CLR1:		// CTR1ؾ
		dwRet = h1px_WritCtr( hDev, 0, MDL_NO1, 0, 1 );	
		if( dwRet ) {
			MntErrMsg( hWnd, dwRet );	// Motionnet Error Message
		}
		break;
	}
	return 0;
}


//
// user timer
//
LRESULT cntTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( wParam ) {
		case IDD_TMR:	cntSts( hWnd );	break;
	}
	return 0 ;
}

//
//	Xe[^XǍ
//
void cntSts( HWND hWnd )
{
	DWORD	dwRet = 0,
			dwRst,
			dwEst,
			dwIst,
			dwSpd;
	long	lCtr;
	WORD	wMst;
	BYTE	byData;

	// ӰҲݽðǏo
	dwRet = h1px_ReadMainSts( hDev, 0, MDL_NO1, &wMst );
	if( wMst & 4 ) {							// G9003װ
		dwRet = h1px_ReadErrorSts( hDev, 0, MDL_NO1, &dwEst );	// װðǏo
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );			// ^C}[~
			MntErrMsg( hWnd, dwRet );			// Motionnet Error Message
			return;
		}
		cntMsg( hWnd, dwEst );					// G[\
		if( dwEst & 0x7ff ) {					// G[~
			EnableWindow( GetDlgItem( hWnd, IDD_PACC ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_MACC ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_PFHC ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_MFHC ), TRUE );
		}
	}
	if( wMst & 8 ) {							// G9003Ĕ
		dwRet = h1px_ReadEventSts( hDev, 0, MDL_NO1, &dwIst );	// ĽðǏo
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );			// ^C}[~
			MntErrMsg( hWnd, dwRet );			// Motionnet Error Message
			return;
		}
		if( dwIst & 0x0001 ) {					// ~
			while( wMst & 8 ) {
				dwRet = h1px_ReadMainSts( hDev, 0, MDL_NO1, &wMst );
				if( dwRet ) {
					KillTimer( hWnd, IDD_TMR );		// ^C}[~
					MntErrMsg( hWnd, dwRet );		// Motionnet Error Message
					return;
				}
				Sleep(0);
			}
			EnableWindow( GetDlgItem( hWnd, IDD_PACC ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_MACC ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_PFHC ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDD_MFHC ), TRUE );
		}
	}	

	dwRet = h1px_ReadExSts( hDev, 0, MDL_NO1, &dwRst );		// gðǏo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	if( dwRst & 0x0020 )	
		SendDlgItemMessage( hWnd, IDC_ALM1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_ALM1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x0040 )	
		SendDlgItemMessage( hWnd, IDC_PEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_PEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x0080 )	
		SendDlgItemMessage( hWnd, IDC_MEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hRed );
	else				
		SendDlgItemMessage( hWnd, IDC_MEL1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x0100 )	
		SendDlgItemMessage( hWnd, IDC_OLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_OLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	if( dwRst & 0x10000 )	
		SendDlgItemMessage( hWnd, IDC_EZ, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_EZ, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );
	
	dwRet = h1px_ReadOutp( hDev, 0, MDL_NO1, &byData );		// o߰ēǏo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	if( byData & 0x0001 )	
		SendDlgItemMessage( hWnd, IDC_SON1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_SON1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht );

	
	dwRet = h1px_ReadCtr( hDev, 0, MDL_NO1, 1, &lCtr );		// CTR1Ǐo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	SetDlgItemInt( hWnd, IDD_CTR1, lCtr, TRUE );

	dwRet = h1px_ReadSpd( hDev, 0, MDL_NO1, &dwSpd );			// wߑxǏo
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );				// ^C}[~
		MntErrMsg( hWnd, dwRet );				// Motionnet Error Message
		return;
	}
	SetDlgItemInt( hWnd, IDD_SPD1, dwSpd, FALSE );
}

//	Ã_CAO{bNX̏
void cntLoad( HWND hWnd )	
{	
	// {^ݒ	
	CheckDlgButton( hWnd, ID_CHK_ELS1, BST_UNCHECKED );
	CheckDlgButton( hWnd, ID_CHK_ALM1, BST_UNCHECKED );

	// 쑬xGfB^ݒ
	SetDlgItemInt( hWnd, IDD_RFH1, 4000, FALSE );
	SendDlgItemMessage( hWnd, IDD_RFH1, EM_SETLIMITTEXT, 5, 0 );
}

// G9003 G[Iv\
void cntMsg( HWND hWnd, DWORD code )
{
	char buf[1024];
	strcpy( buf, "" );
	if( code == 0 )				strcat( buf, "I." );
	if( code & 0x00000001 )		strcat( buf, "CMP1ɂ~.\n" );
	if( code & 0x00000002 )		strcat( buf, "CMP2ɂ~.\n" );
	if( code & 0x00000004 )		strcat( buf, "CMP3ɂ~.\n" );
	if( code & 0x00000008 )		strcat( buf, "+ELSɂ~.\n" );
	if( code & 0x00000010 )		strcat( buf, "-ELSɂ~.\n" );
	if( code & 0x00000020 )		strcat( buf, "SVALMɂ~.\n" );
	if( code & 0x00000040 )		strcat( buf, "CSTPɂ~.\n" );
	if( code & 0x00000100 )		strcat( buf, "DLSɂ~.\n" );
	if( code & 0x00000200 )		strcat( buf, "ٽޯ̧ް۰.\n" );
	if( code & 0x00000400 )		strcat( buf, "ʐMװɂ~.\n" );
	if( code & 0x00001000 )		strcat( buf, "ʒu̵ײގs.\n" );
	if( code & 0x00006000 )		strcat( buf, "װ.\n" );
	SetDlgItemText( hWnd, IDD_STATUS, buf );
}

